#================================================================#
# ADMINS
#================================================================#

import es
from etmod_2008.logs.logs import *
from etmod_2008.players.players import *

#___________________________________________CLASSES

# ------------ #
# CLASSES #
# ------------ #
''' Used to represent an admin '''
class Admin:
	def __init__(self, player, level):
		self.Player = player
		self.Level = level
	def CanConfigureMod(self):
		return self.Level > 0
	def CanConfigureServer(self):
		return self.Level > 0
	def CanManagePlayers(self):
		return self.Level > 2
	def CanManageStats(self):
		return self.Level > 2
	def CanManageOtherFunctionalities(self):
		return self.Level > 1
	def CanExecuteCommands(self):
		return self.Level > 3
	def __str__(self):
		return \
			"Player: " + str(self.Player) + "\n" +\
			"Level: " + str(self.Level)
			
#___________________________________________DECLARATIONS

# --------------------- #
# DECLARATIONS #
# --------------------- #
adminsConfigPath = "cstrike/addons/eventscripts/etmod_2008/admins/configuration"
admins = {}

#___________________________________________SERVER EVENTS

# --------------------- #
# SERVER EVENTS #
# --------------------- #
''' Script loaded '''
def load():
	# Load admins file
	f = None
	try:
		curPath = os.path.join(os.getcwd(), os.path.join(adminsConfigPath, "admins.cfg"))
		
		f = open(curPath, "r")
		for line in f:
			parts = line.split("=")
			if len(parts) == 2:
				parts[1] = parts[1].strip("\n")
				parts[1] = parts[1].strip("\r")
				log("Admin: " + str(parts[0]) + " with level " + str(parts[1]))
				admins[str(parts[0])] = Admin(str(parts[0]), int(parts[1]))
	except:
		log("Error while trying to load admins file")
	finally:
		if f is not None:
			f.close()
	
	# Log
	log("Admins sub-script loaded")
	
''' Script unloaded '''
def unload():
	# Log
	log("Admins sub-script unloaded")