#================================================================#
# MENUS
#================================================================#

import es
import popuplib
from etmod_2008.languages.languages import *
from etmod_2008.logs.logs import *
from etmod_2008.classes.classes import *
from etmod_2008.skills.skills import *
from etmod_2008.players.players import *
from etmod_2008.admins.admins import *
from etmod_2008.server.server import *

#___________________________________________HANDLING FUNCTIONS

# ------------------------------- #
# HANDLING FUNCTIONS #
# ------------------------------- #
def menuSendBack(userid, choice, popupname):
	userid = str(userid)
	popuplib.gPopups[popupname].send(userid)
def menuMainHandler(userid, choice, popupname):
	choice = int(choice)
	userid = str(userid)
	
	if choice == 1:
		showMenuChooseClass(userid)
	elif choice == 2:
		showMenuStats(userid)
	elif choice == 3:
		showMenuPreferences(userid)
	elif choice == 4:
		showMenuBuy(userid)
	elif choice == 5:
		if admins.has_key(players[userid].SteamID):
			showMenuAdmin(userid)
		else:
			l = players[userid].Preferences.Language
			es.tell(userid, l.Translate("You are not an admin"))
	elif choice == 8:
		showMenuHelp(userid)
	elif choice == 9:
		showMenuAbout(userid)
def menuChooseClassHandler(userid, choice, popupname):
	userid = str(userid)
	if choice in classes.keys() and userid in players.keys():
		joinClass(players[userid], classes[choice])
		# Send menu back if player couldn't choose that class
		if players[userid].Class != classes[choice]:
			menuSendBack(userid, choice, popupname)
def menuSelectClassHandler(userid, choice, popupname):
	userid = str(userid)
	if choice in classes.keys() and userid in players.keys():
		players[userid].Situation.Selection = choice
		updateMenuStats(players[userid])
		popuplib.gPopups["etMenuStats"].send(userid)
def menuStatsHandler(userid, choice, popupname):
	userid = str(userid)
	choice = str(choice)
	if choice == "save":
		p = players[userid]
		l = p.Preferences.Language
		p.SaveStats()
		es.tell(userid, l.Translate("Stats saved"))
	updateMenuStats(players[userid])
	menuSendBack(userid, choice, popupname)
def menuPreferencesHandler(userid, choice, popupname):
	userid = str(userid)
	if int(choice) == 1:
		showMenuChooseLanguage(userid)
	elif int(choice) == 2:
		players[userid].Preferences.InGameInfo = not players[userid].Preferences.InGameInfo
		updateMenuPreferences(players[userid])
		menuSendBack(userid, choice, popupname)
	else:
		menuSendBack(userid, choice, popupname)
def menuChooseLanguageHandler(userid, choice, popupname):
	userid = str(userid)
	
	players[userid].Preferences.Language = languages[choice]
	
	updateMenuChooseLanguage(players[userid])
	updateMenuMain(players[userid])
	menuSendBack(userid, choice, popupname)
def menuAdminHandler(userid, choice, popupname):
	userid = str(userid)
	choice = int(choice)
	
	if choice == 1:
		showMenuModConfig(userid)
	elif choice == 2:
		showMenuServerConfig(userid)
	elif choice == 3:
		showMenuChoosePlayer1(userid)
	elif choice == 4:
		showMenuChoosePlayer2(userid)
	elif choice == 5:
		showMenuChoosePlayer3(userid)
	elif choice == 6:
		showMenuModCommands(userid)
	elif choice == 7:
		showMenuOtherFunctionalities(userid)
def menuModConfigHandler(userid, choice, popupname):
	userid = str(userid)
	choice = str(choice)
	l = players[userid].Preferences.Language
	
	# Check if he can configure the mod
	if admins[players[userid].SteamID].CanConfigureMod():
		if	choice == "et_restrict_classes" or\
			choice == "et_restrict_players_in_classes" or\
			choice == "et_unlimited_ammo" or\
			choice == "et_no_reload" or\
			choice == "et_synchronized_spawn" or\
			choice == "et_random_classes" or\
			choice == "et_use_colors" or\
			choice == "et_hurt_lose_xp":
			cur = es.getInt(choice)
			if cur == 0:
				es.set(choice, "1")
			else:
				es.set(choice, "0")
		elif choice == "et_spawn_delay":
			delay = es.getInt("et_spawn_delay")
			delay += 1
			if delay > 120:
				delay = 0
			es.set("et_spawn_delay", delay)
		elif choice == "et_spawn_protection_time":
			time = es.getInt("et_spawn_protection_time")
			time += 1
			if time > 60:
				time = 0
			es.set("et_spawn_protection_time", time)
		elif choice == "et_round_xp":
			xp = es.getInt("et_round_xp")
			xp += 10
			if xp > 1000:
				xp = 0
			es.set("et_round_xp", xp)
		elif choice == "et_round_money":
			money = es.getInt("et_round_money")
			money += 100
			if money > 10000:
				money = 0
			es.set("et_round_money", money)
		elif choice == "et_noconfig_map_behaviour":
			val = es.getString("et_noconfig_map_behaviour")
			if val == "keep":
				val = "default"
			elif val == "default":
				val = "keep"
			es.set("et_noconfig_map_behaviour", val)
			
		# Ask if config files should be updated or not
		showMenuModApplyConfig(userid)
	# Otherwise, tell him
	else:
		es.tell(userid, l.Translate("You're not allowed to modify the mod config"))	
		updateMenuModConfig(players[userid])
		menuSendBack(userid, choice, popupname)
def menuModApplyConfigHandler(userid, choice, popupname):
	choice = int(choice)
	userid = str(userid)	
	l = players[userid].Preferences.Language
	
	# Choice 2 = save to current map config file
	if choice == 2:
		# Retreive current config
		config = ModConfig(str(server_var["eventscripts_currentmap"]))
		config.GetCurrent()
		config.SaveToFile()
	# Choice 3 = save to config file for all maps on the server
	elif choice == 3:
		mapsPath = os.path.join(os.getcwd(), "cstrike/maps")
		config = ModConfig("tmp")
		config.GetCurrent()
		for fpath in os.listdir(mapsPath):
			tailParts = os.path.splitext(fpath)
			fileName = tailParts[0]
			ext = tailParts[1]
			if ext == ".bsp":
				config.SaveToFile(fileName)
	# Choice 1 = only for now ; other choices won't be correct
	elif choice != 1:
		menuSendBack(userid, choice, popupname)
		
	# If ok, send back previous menu
	if choice == 1 or choice == 2 or choice == 3:
		showMenuModConfig(userid)	
def menuServerConfigHandler(userid, choice, popupname):
	userid = str(userid)
	choice = str(choice)
	l = players[userid].Preferences.Language
	
	# Check if he can configure the mod
	if admins[players[userid].SteamID].CanConfigureServer():
		if	choice == "mp_autoteambalance" or\
			choice == "mp_friendlyfire" or\
			choice == "bot_join_after_player" or\
			choice == "mp_fadetoblack" or\
			choice == "mp_flashlight" or\
			choice == "mp_footsteps" or\
			choice == "mp_tkpunish":
			cur = es.getInt(choice)
			if cur == 0:
				es.set(choice, "1")
			else:
				es.set(choice, "0")
		elif choice == "bot_quota":
			val = es.getInt("bot_quota")
			val += 1
			if val > 32:
				val = 0
			es.set("bot_quota", val)
		elif choice == "bot_join_delay":
			val = es.getInt("bot_join_delay")
			val += 1
			if val > 30:
				val = 0
			es.set("bot_join_delay", val)
		elif choice == "mp_c4timer":
			val = es.getInt("mp_c4timer")
			val += 1
			if val > 90:
				val = 10
			es.set("mp_c4timer", val)
		elif choice == "mp_chattime":
			val = es.getInt("mp_chattime")
			val += 1
			if val > 120:
				val = 1
			es.set("mp_chattime", val)
		elif choice == "mp_freezetime":
			val = es.getInt("mp_freezetime")
			val += 1
			if val > 60:
				val = 0
			es.set("mp_freezetime", val)
		elif choice == "mp_maxrounds":
			val = es.getInt("mp_maxrounds")
			val += 1
			if val > 20:
				val = 0
			es.set("mp_maxrounds", val)
		elif choice == "mp_roundtime":
			val = es.getInt("mp_roundtime")
			val += 1
			if val > 9:
				val = 1
			es.set("mp_roundtime", val)
		elif choice == "mp_timelimit":
			val = es.getInt("mp_timelimit")
			val += 1
			if val > 120:
				val = 0
			es.set("mp_timelimit", val)
		elif choice == "mp_winlimit":
			val = es.getInt("mp_winlimit")
			val += 1
			if val > 20:
				val = 0
			es.set("mp_winlimit", val)
		elif choice == "hostname":
			val = es.getString("hostname")
			if val == "-< [ETmod2008 by McFly] >-":
				val = "> ETmod2008 by McFly <"
			elif val == "> ETmod2008 by McFly <":
				val = "-= ETmod2008 by McFly =-"
			else:
				val = "-< [ETmod2008 by McFly] >-"
			es.set("hostname", val)
		elif choice == "bot_quota_mode":
			val = es.getString("bot_quota_mode")
			if val == "normal":
				val = "fill"
			elif val == "fill":
				val = "match"
			else:
				val = "normal"
			es.set("bot_quota_mode", val)
		elif choice == "bot_join_team":
			val = es.getString("bot_join_team")
			if val == "any":
				val = "T"
			elif val == "T":
				val = "CT"
			else:
				val = "any"
			es.set("bot_join_team", val)
			
		# Ask if config files should be updated or not
		showMenuServerApplyConfig(userid)
	# Otherwise, tell him
	else:
		es.tell(userid, l.Translate("You're not allowed to modify the server config"))
		updateMenuServerConfig(players[userid])
		menuSendBack(userid, choice, popupname)
def menuServerApplyConfigHandler(userid, choice, popupname):
	choice = int(choice)
	userid = str(userid)	
	l = players[userid].Preferences.Language
	
	# Choice 2 = save to current map config file
	if choice == 2:
		# Retreive current config
		config = ServerConfig(str(server_var["eventscripts_currentmap"]))
		config.GetCurrent()
		config.SaveToFile()
	# Choice 3 = save to config file for all maps on the server
	elif choice == 3:
		mapsPath = os.path.join(os.getcwd(), "cstrike/maps")
		config = ServerConfig("tmp")
		config.GetCurrent()
		for fpath in os.listdir(mapsPath):
			tailParts = os.path.splitext(fpath)
			fileName = tailParts[0]
			ext = tailParts[1]
			if ext == ".bsp":
				config.SaveToFile(fileName)
	# Choice 1 = only for now ; other choices won't be correct
	elif choice != 1:
		menuSendBack(userid, choice, popupname)
		
	# If ok, send back previous menu
	if choice == 1 or choice == 2 or choice == 3:
		showMenuServerConfig(userid)
def menuModCommandsHandler(userid, choice, popupname):
	userid = str(userid)
	choice = str(choice)
	p = players[userid]
	l = p.Preferences.Language
	
	# Check if he can use mod commands
	if admins[p.SteamID].CanExecuteCommands():
		es.server.queuecmd(choice)
	# Otherwise, tell him
	else:
		es.tell(userid, l.Translate("You're not allowed to execute mod commands"))
		
	updateMenuModCommands(players[userid])
	menuSendBack(userid, choice, popupname)
def menuChoosePlayer1Handler(userid, choice, popupname):
	userid = str(userid)
	choice = str(choice)
	
	if players.has_key(choice):
		players[userid].Situation.Page = choice
		showMenuPlayerManagement(userid)
	else:
		updateMenuChoosePlayer1(players[userid])
		menuSendBack(userid, choice, popupname)
def menuChoosePlayer2Handler(userid, choice, popupname):
	userid = str(userid)
	choice = str(choice)
	
	if players.has_key(choice):
		players[userid].Situation.Page = choice
		showMenuStatsManagement(userid)
	else:
		updateMenuChoosePlayer2(players[userid])
		menuSendBack(userid, choice, popupname)
def menuChoosePlayer3Handler(userid, choice, popupname):
	userid = str(userid)
	choice = str(choice)
	
	if players.has_key(choice):
		players[userid].Situation.Page = choice
		showMenuSkillsManagement(userid)
	else:
		updateMenuChoosePlayer3(players[userid])
		menuSendBack(userid, choice, popupname)
def menuPlayerManagementHandler(userid, choice, popupname):
	userid = str(userid)
	choice = str(choice)
	player = players[userid].Situation.Page
	l = players[userid].Preferences.Language
	p = players[player]
	pl = p.Preferences.Language
	
	if choice == "slap":
		pass
	elif choice == "burn":
		es.server.queuecmd("est_Burn " + player + " 30")
		es.tell(userid, l.Translate("\\x04" + p.Name + " \\x03is now burning"))
		es.tell(player, pl.Translate("\\x03You've been turned into a human torch by an admin"))
	elif choice == "slay":
		es.server.queuecmd("est_SetHealth " + player + " 1")
		es.server.queuecmd("est_Burn " + player + " 1")
		es.tell(userid, l.Translate("\\x04" + p.Name + " \\x03has been slayed"))
		es.tell(player, pl.Translate("\\x03You've been slayed by an admin"))
	elif choice == "freeze":
		es.server.queuecmd("est_Freeze " + player + " 1")
		es.tell(userid, l.Translate("\\x04" + p.Name + " \\x03is now frozen"))
		es.tell(player, pl.Translate("\\x03You got frozen by an admin"))
	elif choice == "unfreeze":
		es.server.queuecmd("est_Freeze " + player + " 0")
		es.tell(userid, l.Translate("\\x04" + p.Name + " \\x03is now able to move"))
		es.tell(player, pl.Translate("\\x03You got unfrozen by \\x04an admin"))
	elif choice == "spec":
		es.server.queuecmd("est_Team " + player + " 1")
		es.tell(userid, l.Translate("\\x03Moved %%tmp%% to spectators").replace("%%tmp%%", "\\x04" + p.Name + "\\x03").decode("string_escape"))
		es.tell(player, pl.Translate("\\x03You've been moved to spectators by an admin"))
	elif choice == "switch":
		if p.Team == 2:
			es.server.queuecmd("est_Team " + player + " 3")
			es.tell(userid, l.Translate("\\x03Swapped %%tmp%% to counter-terrorists").replace("%%tmp%%", "\\x04" + p.Name + "\\x03").decode("string_escape"))
			es.tell(player, pl.Translate("\\x03You've been swapped to counter-terrorists by an admin"))
		elif p.Team == 3:
			es.server.queuecmd("est_Team " + player + " 2")
			es.tell(userid, l.Translate("\\x03Swapped %%tmp%% to terrorists").replace("%%tmp%%", "\\x04" + p.Name + "\\x03").decode("string_escape"))
			es.tell(player, pl.Translate("\\x03You've been swapped to terrorists by an admin"))
		else:
			es.tell(userid, l.Translate("\\x04" + p.Name + " \\x03is not playing currently"))
	elif choice == "stuck":
		es.server.queuecmd("es_setinfo x 0;es_setinfo y 0;es_setinfo z 0;es_getplayerlocation x y z " + player +\
			";es_math z - 100;es_setpos " + player + " server_var(x) server_var(y) server_var(z)")
		es.tell(userid, l.Translate("\\x03Moved %%tmp%% down a little to get him stuck into the floor").replace("%%tmp%%", "\\x04" + p.Name + "\\x03").decode("string_escape"))
		es.tell(player, pl.Translate("\\x03You've been moved into the floor by an admin to get you stuck"))
	elif choice == "unstuck":
		es.server.queuecmd("es_setinfo x 0;es_setinfo y 0;es_setinfo z 0;es_getplayerlocation x y z " + player +\
			";es_math z + 100;es_setpos " + player + " server_var(x) server_var(y) server_var(z)")
		es.tell(userid, l.Translate("\\x03Moved %%tmp%% up a little to get him back on the floor").replace("%%tmp%%", "\\x04" + p.Name + "\\x03").decode("string_escape"))
		es.tell(player, pl.Translate("\\x03You've been moved back up by an admin in order for you not to be stuck anymore"))
	elif choice == "kick":
		pass
	elif choice == "ban":
		pass
	elif choice == "noclass":
		joinClass(p, classes["noclass"], True)
		es.tell(userid, l.Translate("\\x04" + p.Name + " \\x03now doesn't have a class"))
		es.tell(player, l.Translate("\\x03You've been moved to no class by an admin"))
	elif choice == "class":
		# Get the next class
		ci = -1
		cl = classes["noclass"]
		for c in classes.values():
			ci += 1
			if c == p.Class:
				cl = c
				break
				
		# In case player's current class couldn't be found
		if ci == -1:
			es.tell(userid, l.Translate("\\x03Impossible to do currently"))
			return
			
		# Get next class
		ci += 1
		if ci == len(classes.keys()) - 1: ci = 0
		ncl = classes[classes.keys()[ci]]
		joinClass(p, ncl, True)
		es.tell(userid, l.Translate("\\x04" + p.Name + " \\x03moved to class \\x04" + ncl.Name))
		es.tell(player, pl.Translate("\\x03You've been moved to class %%tmp%% by an admin").replace("%%tmp%%", "\\x04" + ncl.Name + "\\x03").decode("string_escape"))
	elif choice == "remwep":
		es.server.queuecmd("est_StripPlayer " + player)
		es.server.queuecmd("est_RestrictAll " + player)
		es.tell(userid, l.Translate("\\x04" + p.Name + " \\x03now cannot use any weapons"))
		es.tell(player, pl.Translate("\\x03An admin removed and restricted your weapons"))
	elif choice == "poison":
		pass
	elif choice == "spawn":
		es.server.queuecmd("est_Spawn " + player + " 1")
		es.tell(userid, l.Translate("\\x04" + p.Name + " \\x03has respawned"))
		es.tell(player, pl.Translate("\\x03You've been respawned by an admin"))
	
	updateMenuPlayerManagement(players[userid])
	menuSendBack(userid, choice, popupname)
def menuStatsManagementHandler(userid, choice, popupname):
	userid = str(userid)
	choice = str(choice)
	
	menuSendBack(userid, choice, popupname)
def menuSkillsManagementHandler(userid, choice, popupname):
	userid = str(userid)
	choice = str(choice)
	
	menuSendBack(userid, choice, popupname)
def menuOtherFunctionalitiesHandler(userid, choice, popupname):
	userid = str(userid)
	choice = str(choice)
	
	updateMenuOtherFunctionalities(players[userid])
	menuSendBack(userid, choice, popupname)
def menuHelpHandler(userid, choice, popupname):
	userid = str(userid)
	choice = int(choice)
	
	if choice == 1:
		showMenuRules(userid)
	elif choice == 2:
		showMenuChatCommands(userid)
	elif choice == 3:
		showMenuConsoleCommands(userid)
	elif choice == 4:
		showMenuClassesInfo(userid)
def menuRulesHandler(userid, choice, popupname):
	userid = str(userid)	
	menuSendBack(userid, choice, popupname)
def menuChatCommandsHandler(userid, choice, popupname):
	userid = str(userid)	
	menuSendBack(userid, choice, popupname)
def menuConsoleCommandsHandler(userid, choice, popupname):
	userid = str(userid)
	menuSendBack(userid, choice, popupname)
def menuClassesInfoHandler(userid, choice, popupname):
	userid = str(userid)
	if choice in classes.keys() and userid in players.keys():
		# Store current selection in player's config
		players[userid].Situation.Page = choice
		# Send class config menu
		showMenuClassInfo(userid)
def menuClassInfoHandler(userid, choice, popupname):
	userid = str(userid)
def menuBuyHandler(userid, choice, popupname):
	userid = str(userid)
	choice = int(choice)
	s = players[userid].Stats
	
	if choice == 1:
		showMenuUpgradeClass(userid)
	elif choice == 2:
		showMenuLearnSkills(userid)
	elif choice == 3:
		showMenuArmory(userid)
	# Save current money
	elif choice == 4:
		s.SavedMoney += s.Money
		s.Money = 0
		showMenuBuy(userid)
	# Retreive saved money
	elif choice == 5:
		s.Money += s.SavedMoney
		s.SavedMoney = 0
		showMenuBuy(userid)
def menuUpgradeClassHandler(userid, choice, popupname):
	# Get info
	userid = str(userid)
	choice = str(choice)
	player = players[userid]
	s = player.Stats
	c = player.Class
	u = c.Upgrades
	p = player.Preferences
	l = p.Language
	b = player.BoughtStuff
	money = s.Money
	
	# Health point
	if choice == "health":
		# Get info
		price = u.CurrentPrice(u.HealthPrice, s.GetLevel(c.Name), b.Classes[c.Name]["health"])
		
		# If player doesn't have enough money left, tell him
		if money < price:
			es.tell(userid, l.Translate("You don't have enough money to buy health"))
		# Otherwise, update info
		else:
			# Update money
			s.Money -= price
			
			# Update bought stuff
			b.Classes[c.Name]["health"] += 1
			
			# Info message
			es.tell(userid, l.Translate("You successfully bought one more health point for class '" + c.Name + "'"))
			
	# Armor point
	elif choice == "armor":
		# Get info
		price = u.CurrentPrice(u.ArmorPrice, s.GetLevel(c.Name), b.Classes[c.Name]["armor"])
		
		# If player doesn't have enough money left, tell him
		if money < price:
			es.tell(userid, l.Translate("You don't have enough money to buy armor"))
		# Otherwise, update info
		else:
			# Update money
			s.Money -= price
			
			# Update bought stuff
			b.Classes[c.Name]["armor"] += 1
			
			# Info message
			es.tell(userid, l.Translate("You successfully bought one more armor point for class '" + c.Name + "'"))
			
	# Speed point
	elif choice == "speed":
		# Get info
		price = u.CurrentPrice(u.SpeedPrice, s.GetLevel(c.Name), b.Classes[c.Name]["speed"])
		
		# If player doesn't have enough money left, tell him
		if money < price:
			es.tell(userid, l.Translate("You don't have enough money to buy speed"))
		# Otherwise, update info
		else:
			# Update money
			s.Money -= price
			
			# Update bought stuff
			b.Classes[c.Name]["speed"] += 1
			
			# Info message
			es.tell(userid, l.Translate("You successfully bought one more speed point for class '" + c.Name + "'"))
	
	showMenuUpgradeClass(userid)
def menuLearnSkillsHandler(userid, choice, popupname):
	# Get info
	userid = str(userid)
	choice = str(choice)
	player = players[userid]
	skill = skills[choice]
	stats = player.Stats.Classes.get(player.Class.Name, None)
	
	# If player cannot learn that skill yet, tell him
	if stats is None or player.Stats.GetLevel(player.Class.Name) < skill.Level:
		es.tell(userid, "You need to reach level " + str(skill.Level) + " before being able to learn that skill")
		menuSendBack(userid, choice, popupname)
	# Otherwise display the upgrade skill menu
	else:
		# If he doesn't yet have it, add it and tell him he learnt it
		if not player.Skills.has_key(choice):
			es.tell(userid, "You learnt skill " + skill.Name)
			player.Skills[choice] = PlayerSkill(player, skill)
		player.Situation.Selection = player.Skills[choice]
		showMenuUpgradeSkill(userid)
def menuArmoryHandler(userid, choice, popupname):
	# Get info
	userid = str(userid)
	choice = str(choice)
	player = players[userid]
	s = player.Stats
	c = player.Class
	u = c.Upgrades
	p = player.Preferences
	l = p.Language
	b = player.BoughtStuff
	money = s.Money
	
	# Primary ammo
	if choice == "primammo":
		price = 0
		
		# Terrorists
		if player.Team == 2:
			# Get info
			price = u.CurrentPrice(u.PrimaryAmmoPriceT, s.GetLevel(c.Name), b.Classes[c.Name]["primary_ammo_t"])
			
		# Counter-Terrorists
		elif player.Team == 3:
			# Get info
			price = u.CurrentPrice(u.PrimaryAmmoPriceCT, s.GetLevel(c.Name), b.Classes[c.Name]["primary_ammo_ct"])
		
		# If player doesn't have enough money left, tell him
		if money < price:
			es.tell(userid, l.Translate("You don't have enough money to buy more primary bullet"))
			
		# If he already bought enough primary ammo, tell him
		elif	(player.Team == 2 and b.Classes[c.Name]["primary_ammo_t"] >= u.MaxAmmoPrimaryT) or\
				(player.Team == 3 and b.Classes[c.Name]["primary_ammo_ct"] >= u.MaxAmmoPrimaryCT):
			es.tell(userid, l.Translate("You have already bought enough primary ammo for that team"))
			
		# Otherwise, update info
		else:
			# Update money
			s.Money -= price
			
			# Update bought stuff
			if player.Team == 2:
				b.Classes[c.Name]["primary_ammo_t"] += 1
			elif player.Team == 3:
				b.Classes[c.Name]["primary_ammo_ct"] += 1
			
			# Info message
			if player.Team == 2:
				es.tell(userid, l.Translate("You successfully bought one more T primary ammo bullet point for class '" + c.Name + "'"))
			elif player.Team == 3:
				es.tell(userid, l.Translate("You successfully bought one more CT primary ammo bullet point for class '" + c.Name + "'"))
			
	# Secondary ammo
	elif choice == "secammo":
		price = 0
		
		# Terrorists
		if player.Team == 2:
			# Get info
			price = u.CurrentPrice(u.SecondaryAmmoPriceT, s.GetLevel(c.Name), b.Classes[c.Name]["secondary_ammo_t"])
			
		# Counter-Terrorists
		elif player.Team == 3:
			# Get info
			price = u.CurrentPrice(u.SecondaryAmmoPriceCT, s.GetLevel(c.Name), b.Classes[c.Name]["secondary_ammo_ct"])
		
		# If player doesn't have enough money left, tell him
		if money < price:
			es.tell(userid, l.Translate("You don't have enough money to buy more secondary bullet"))
			
		# If he already bought enough primary ammo, tell him
		elif	(player.Team == 2 and b.Classes[c.Name]["secondary_ammo_t"] >= u.MaxAmmoSecondaryT) or\
				(player.Team == 3 and b.Classes[c.Name]["secondary_ammo_ct"] >= u.MaxAmmoSecondaryCT):
			es.tell(userid, l.Translate("You have already bought enough secondary ammo for that team"))
			
		# Otherwise, update info
		else:
			# Update money
			s.Money -= price
			
			# Update bought stuff
			if player.Team == 2:
				b.Classes[c.Name]["secondary_ammo_t"] += 1
			elif player.Team == 3:
				b.Classes[c.Name]["secondary_ammo_ct"] += 1
			
			# Info message
			if player.Team == 2:
				es.tell(userid, l.Translate("You successfully bought one more T secondary ammo bullet point for class '" + c.Name + "'"))
			elif player.Team == 3:
				es.tell(userid, l.Translate("You successfully bought one more CT secondary ammo bullet point for class '" + c.Name + "'"))
			
	# Inventory
	elif choice == "inventory":
		price = 0
		
		# Terrorists
		if player.Team == 2:
			# Get info
			price = u.CurrentPrice(u.InventoryPriceT, s.GetLevel(c.Name), b.Classes[c.Name]["inv_amount_t"])
			
		# Counter-Terrorists
		elif player.Team == 3:
			# Get info
			price = u.CurrentPrice(u.InventoryPriceCT, s.GetLevel(c.Name), b.Classes[c.Name]["inv_amount_ct"])
		
		# If player doesn't have enough money left, tell him
		if money < price:
			if player.Team == 2:
				es.tell(userid, l.Translate("You don't have enough money to buy one more " + str(c.InventoryT)))
			elif player.Team == 3:
				es.tell(userid, l.Translate("You don't have enough money to buy one more " + str(c.InventoryCT)))
				
		# If he already bought enough primary ammo, tell him
		elif	(player.Team == 2 and b.Classes[c.Name]["inv_amount_t"] >= u.MaxInvAmountT) or\
				(player.Team == 3 and b.Classes[c.Name]["inv_amount_ct"] >= u.MaxInvAmountCT):
			es.tell(userid, l.Translate("You have already bought enough ivnentory items for that team"))
			
		# Otherwise, update info
		else:
			# Update money
			s.Money -= price
			
			# Update bought stuff
			if player.Team == 2:
				b.Classes[c.Name]["inv_amount_t"] += 1
			elif player.Team == 3:
				b.Classes[c.Name]["inv_amount_ct"] += 1
			
			# Info message
			if player.Team == 2:
				es.tell(userid, l.Translate("You successfully bought one more T " + str(c.InventoryT) + " for class '" + c.Name + "'"))
			elif player.Team == 3:
				es.tell(userid, l.Translate("You successfully bought one more CT " + str(c.InventoryCT) + " for class '" + c.Name + "'"))
			
	# Better weapon
	elif choice == "weapon":
		price = 0
		
		# Terrorists
		if player.Team == 2:
			# Get info
			price = u.CurrentPrice(u.BetterWeaponPriceT, s.GetLevel(c.Name), 1)
			
		# Counter-Terrorists
		elif player.Team == 3:
			# Get info
			price = u.CurrentPrice(u.BetterWeaponPriceCT, s.GetLevel(c.Name), 1)
		
		# If player doesn't have enough money left, tell him
		if money < price:
			if player.Team == 2:
				es.tell(userid, l.Translate("You don't yet have enough money to buy your T " + str(u.BetterWeaponT)))
			elif player.Team == 3:
				es.tell(userid, l.Translate("You don't yet have enough money to buy your CT " + str(u.BetterWeaponCT)))
				
		# If player has already bought it, tell him
		elif player.Team == 2 and b.Classes[c.Name]["better_weapon_t"]:
				es.tell(userid, l.Translate("You have already bought your T " + str(u.BetterWeaponT)))
		elif player.Team == 3 and b.Classes[c.Name]["better_weapon_ct"]:
				es.tell(userid, l.Translate("You have already bought your CT " + str(u.BetterWeaponCT)))
			
		# Otherwise, update info
		else:
			# Update money
			s.Money -= price
			
			# Update bought stuff
			if player.Team == 2:
				b.Classes[c.Name]["better_weapon_t"] = True
			elif player.Team == 3:
				b.Classes[c.Name]["better_weapon_ct"] = True
			
			# Info message
			if player.Team == 2:
				es.tell(userid, l.Translate("You successfully bought your T " + str(u.BetterWeaponT) + " for class '" + c.Name + "'"))
			elif player.Team == 3:
				es.tell(userid, l.Translate("You successfully bought one more CT " + str(u.BetterWeaponCT) + " for class '" + c.Name + "'"))
			
	
	showMenuArmory(userid)
def menuUpgradeSkillHandler(userid, choice, popupname):
	# Get info	
	userid = str(userid)
	choice = str(choice)	
	player = players[userid]
	l = player.Preferences.Language
	stats = player.Stats
	c = player.Class
	pskill = player.Situation.Selection
	skill = pskill.Skill
	
	# Buy one unit
	if choice == "buy":
		# Get info
		price = skill.CurrentPrice(1, stats.GetLevel(c.Name))
		
		# If not enough money, warn him
		if stats.Money < price:
			es.tell(userid, l.Translate("You don't have enough money to buy that skill"))
		# Otherwise give him one
		else:
			player.Skills[skill.Name].Amount += 1
			stats.Money -= price
	# Upgrade selected parameter
	elif choice != " ":
		# Get info
		choice = int(choice)
		paramType = skillParameterNames[choice]
		param = skill.Parameters[paramType]
		prog = pskill.Progression.get(choice, None)
		price = 0
		if prog is None: price = param.CurrentPrice(1, stats.GetLevel(c.Name))
		else: price = param.CurrentPrice(prog, stats.GetLevel(c.Name))
		
		# If not enough money, warn him
		if stats.Money < param.Price:
			es.tell(userid, l.Translate("You don't have enough money to upgrade that skill parameter"))
		# If already at max, warn him
		elif prog is not None and prog >= param.Max:
			es.tell(userid, l.Translate("That parameter is already at max"))
		# Otherwise, upgrade it
		else:
			if prog is None:
				pskill.Progression[choice] = param.Default
			pskill.Progression[choice] += param.Add
			stats.Money -= param.Price
			es.tell(userid, l.Translate("Skill '" + paramType + "'parameter upgraded"))
			
	# Refresh menu
	showMenuUpgradeSkill(userid)
def menuChooseSkillHandler(userid, choice, popupname):
	# Get info
	userid = str(userid)
	choice = str(choice)
	player = players[userid]
	pskill = player.Skills[choice]
	l = player.Preferences.Language
	
	# Warn him if he's dead
	if not player.Situation.Alive:
		es.tell(userid, l.Translate("Dead players cannot use skills"))	
	# Otherwise, make him use his skill
	else:
		es.server.queuecmd("est_CExec " + userid + " et_skill " + choice)
	
	# Refresh menu
	showMenuChooseSkill(userid)
def menuQuickStatsHandler(userid, choice, popupname):
	userid = str(userid)
	choice = int(choice)
	
	# Show main menu if needed
	if choice == 9:
		showMenuMain(userid)
		
#___________________________________________CREATION

# -------------- #
# CREATION #
# -------------- #

# Main menu #
#--------------#
menuMain = popuplib.create("etMenuMain")

# Class choice menu #
#-----------------------#
menuChooseClass = popuplib.easymenu("etMenuChooseClass", "", menuChooseClassHandler)
menuChooseClass.submenu(10, "etMenuMain")

# Class selection menu #
#--------------------------#
menuSelectClass = popuplib.easymenu("etMenuSelectClass", "", menuSelectClassHandler)
menuSelectClass.submenu(10, "etMenuMain")

# Stats view menu #
#---------------------#
menuStats = popuplib.easymenu("etMenuStats", "", menuStatsHandler)
menuStats.submenu(10, "etMenuMain")

# Preferences management menu #
#--------------------------------------#
menuPreferences = popuplib.create("etMenuPreferences")
menuPreferences.submenu(10, "etMenuMain")

# Language selection menu #
#-------------------------------#
menuChooseLanguage = popuplib.easymenu("etMenuChooseLanguage", "", menuChooseLanguageHandler)
menuChooseLanguage.submenu(10, "etMenuMain")

# Help menu #
#--------------#
menuHelp = popuplib.create("etMenuHelp")
menuHelp.submenu(10, "etMenuMain")

# About menu #
#----------------#
menuAbout = popuplib.create("etMenuAbout")
menuAbout.submenu(10, "etMenuMain")

# Buy menu #
#-------------#
menuBuy = popuplib.create("etMenuBuy")
menuBuy.submenu(10, "etMenuMain")

# Upgrade class menu #
#--------------------------#
menuUpgradeClass = popuplib.easymenu("etMenuUpgradeClass", "", menuUpgradeClassHandler)
menuUpgradeClass.submenu(10, "etMenuBuy")

# Learn skills menu #
#----------------------#
menuLearnSkills = popuplib.easymenu("etMenuLearnSkills", "", menuLearnSkillsHandler)
menuLearnSkills.submenu(10, "etMenuBuy")

# Upgrade skill menu #
#-------------------------#
menuUpgradeSkill = popuplib.easymenu("etMenuUpgradeSkill", "", menuUpgradeSkillHandler)
menuUpgradeSkill.submenu(10, "etMenuBuy")

# Armory menu #
#-----------------#
menuArmory = popuplib.easymenu("etMenuArmory", "", menuArmoryHandler)
menuArmory.submenu(10, "etMenuArmory")

# Admin menu #
#----------------#
menuAdmin = popuplib.create("etMenuAdmin")
menuAdmin.submenu(10, "etMenuMain")

# Mod configuration menu #
#-------------------------------#
menuModConfig = popuplib.easymenu("etMenuModConfig", "", menuModConfigHandler)
menuModConfig.submenu(10, "etMenuAdmin")

# Mod configuration destination #
#--------------------------------------#
menuModApplyConfig = popuplib.create("etMenuModApplyConfig")
menuModApplyConfig.submenu(10, "etMenuModApplyConfig")

# Server configuration menu #
#----------------------------------#
menuServerConfig = popuplib.easymenu("etMenuServerConfig", "", menuServerConfigHandler)
menuServerConfig.submenu(10, "etMenuAdmin")

# Server configuration destination #
#-----------------------------------------#
menuServerApplyConfig = popuplib.create("etMenuServerApplyConfig")
menuServerApplyConfig.submenu(10, "etMenuServerApplyConfig")

# Players management menu #
#---------------------------------#
menuChoosePlayer1 = popuplib.easymenu("etMenuChoosePlayer1", "", menuChoosePlayer1Handler)
menuChoosePlayer1.submenu(10, "etAdmin")
menuChoosePlayer2 = popuplib.easymenu("etMenuChoosePlayer2", "", menuChoosePlayer2Handler)
menuChoosePlayer2.submenu(10, "etAdmin")
menuChoosePlayer3 = popuplib.easymenu("etMenuChoosePlayer3", "", menuChoosePlayer3Handler)
menuChoosePlayer3.submenu(10, "etAdmin")
menuPlayerManagement = popuplib.easymenu("etMenuPlayerManagement", "", menuPlayerManagementHandler)
menuPlayerManagement.submenu(10, "etMenuAdmin")

# Stats management menu #
#------------------------------#
menuStatsManagement = popuplib.easymenu("etMenuStatsManagement", "", menuStatsManagementHandler)
menuStatsManagement.submenu(10, "etMenuAdmin")

# Skills management #
#------------------------#
menuSkillsManagement = popuplib.easymenu("etMenuSkillsManagement", "", menuSkillsManagementHandler)
menuSkillsManagement.submenu(10, "etMenuAdmin")

# Mod commands #
#--------------------#
menuModCommands = popuplib.easymenu("etMenuModCommands", "", menuModCommandsHandler)
menuModCommands.submenu(10, "etMenuAdmin")

# Other functionalities menu #
#----------------------------------#
menuOtherFunctionalities = popuplib.easymenu("etMenuOtherFunctionalities", "", menuOtherFunctionalitiesHandler)
menuOtherFunctionalities.submenu(10, "etMenuAdmin")

# Game rules #
#---------------#
menuRules = popuplib.easymenu("etMenuRules", "", menuRulesHandler)
menuRules.submenu(10, "etMenuHelp")

# Chat commands #
#--------------------#
menuChatCommands = popuplib.easymenu("etMenuChatCommands", "", menuChatCommandsHandler)
menuChatCommands.submenu(10, "etMenuHelp")

# Console commands #
#------------------------#
menuConsoleCommands = popuplib.easymenu("etMenuConsoleCommands", "", menuConsoleCommandsHandler)
menuConsoleCommands.submenu(10, "etMenuHelp")

# Class info selection menu #
#----------------------------------#
menuClassesInfo = popuplib.easymenu("etMenuClassesInfo", "", menuClassesInfoHandler)
menuClassesInfo.submenu(10, "etMenuHelp")

# Class config visualisation menu #
#-----------------------------------------#
menuClassInfo = popuplib.easymenu("etMenuClassInfo", "", menuClassInfoHandler)
menuClassInfo.submenu(10, "etMenuHelp")

# Skills (to select for use) #
#-------------------------------#
menuChooseSkill = popuplib.easymenu("etMenuChooseSkill", "", menuChooseSkillHandler)
menuChooseSkill.submenu(10, "etMenuMain")

# Quick stats displaying menu #
#-----------------------------------#
menuQuickStats = popuplib.create("etMenuQuickStats")

#___________________________________________HELP FUNCTIONS

# ------------------------ #
# HELP FUNCTIONS #
# ------------------------ #
''' Recreate the main menu '''
def updateMenuMain(player):
	l = player.Preferences.Language
	menuMain.__init__("etMenuMain")
	menuMain.addline(l.Translate("[ETmod] Main menu"))
	menuMain.addline("-----------------------------")
	menuMain.addline(l.Translate("->1. Choose a class"))
	menuMain.addline(l.Translate("->2. Display stats"))
	menuMain.addline(l.Translate("->3. Manage your preferences"))
	menuMain.addline(l.Translate("->4. Buy stuff"))
	menuMain.addline("-----------------------------")
	menuMain.addline(l.Translate("->5. Administration"))
	menuMain.addline("-----------------------------")
	menuMain.addline(l.Translate("->8. Help"))
	menuMain.addline(l.Translate("->9. About"))
	menuMain.addline("-----------------------------")
	menuMain.addline(l.Translate("->0. Close"))
	menuMain.select(1, menuMainHandler)
	menuMain.select(2, menuMainHandler)
	menuMain.select(3, menuMainHandler)
	menuMain.select(4, menuMainHandler)
	menuMain.select(5, menuMainHandler)
	menuMain.select(6, menuSendBack)
	menuMain.select(7, menuSendBack)
	menuMain.select(8, menuMainHandler)
	menuMain.select(9, menuMainHandler)
	
''' Recreate the classes menu to let players choose their class '''
def updateMenuChooseClass(player):
	l = player.Preferences.Language
	#popuplib.delete("etMenuChooseClass")
	#menuChooseClass = popuplib.easymenu("etMenuChooseClass", "", menuChooseClassHandler)
	menuChooseClass.__init__("etMenuChooseClass", "", menuChooseClassHandler)
	menuChooseClass.settitle(l.Translate("[ETmod] Choose a class"))
	menuChooseClass.submenu(10, "etMenuMain")
	for c in classes.keys():
		menuChooseClass.addoption(c, l.Translate(c))
	
''' Recreate the classes menu to adapt it to let players select a class for stats displaying '''
def updateMenuSelectClass(player):	
	l = player.Preferences.Language
	#popuplib.delete("etMenuSelectClass")
	#menuSelectClass = popuplib.easymenu("etMenuSelectClass", "", menuSelectClassHandler)
	menuSelectClass.__init__("etMenuSelectClass", "", menuSelectClassHandler)
	menuSelectClass.settitle(l.Translate("[ETmod] Select the class to check"))
	menuSelectClass.submenu(10, "etMenuMain")
	for c in classes.keys():
		menuSelectClass.addoption(c, l.Translate(c))
		
''' Recreate the stats menu to refresh player's stats '''
def updateMenuStats(player):
	# Temp variables
	p = player
	c = p.Situation.Selection
	s = p.Stats
	sc = s.Classes
	scc = sc.get(c, None)
	l = p.Preferences.Language
	
	# Menu
	#popuplib.delete("etMenuStats")
	#menuStats = popuplib.easymenu("etMenuStats", "", menuStatsHandler)
	menuStats.__init__("etMenuStats", "", menuStatsHandler)
	menuStats.c_stateformat[False] = "(%2)"
	menuStats.c_stateformat[True] = "%2"
	menuStats.settitle(l.Translate("[ETmod] Stats in class '" + c + "'"))
	menuStats.submenu(10, "etMenuMain")
	
	menuStats.addoption("money", l.Translate("Money: " + str(s.Money)))
	try: menuStats.addoption("level", l.Translate("Level: " + str(s.GetLevel(c))))
	except: menuStats.addoption("level", l.Translate("Level: 0"))
	try: menuStats.addoption("xp", l.Translate("Xp: " + str(scc["xp"])))
	except: menuStats.addoption("xp", l.Translate("Xp: 0"))
	
	menuStats.addoption(" ", " ")
		
	try: menuStats.addoption("kills", l.Translate("Kills: " + str(scc["kills"])))
	except: menuStats.addoption("kills", l.Translate("Kills: 0"))
	try: menuStats.addoption("headshots", l.Translate("Headshots: " + str(scc["headshots"])))
	except: menuStats.addoption("headshots", l.Translate("Headshots: 0"))
	try: menuStats.addoption("knives", l.Translate("Knife kills: " + str(scc["knives"])))
	except: menuStats.addoption("knives", l.Translate("Knife kills: 0"))
	
	menuStats.addoption(" ", " ")
	
	try: menuStats.addoption("deaths", l.Translate("Deaths: " + str(scc["deaths"])))
	except: menuStats.addoption("deaths", l.Translate("Deaths: 0"))
	try: menuStats.addoption("suicides", l.Translate("Suicides: " + str(scc["suicides"])))
	except: menuStats.addoption("suicides", l.Translate("Suicides: 0"))
	try: menuStats.addoption("teamkillsdone", l.Translate("Team-kills: " + str(scc["teamkillsdone"])))
	except: menuStats.addoption("teamkillsdone", l.Translate("Team-kills: 0"))
	
	menuStats.addoption(" ", " ")
	
	if p.Class.Actions.CanHeal():
		try: menuStats.addoption("heals", l.Translate("Health points given: " + str(scc["heals"])))
		except: menuStats.addoption("heals", l.Translate("Health points given: 0"))
	if p.Class.Actions.CanSupply():
		try: menuStats.addoption("supplies", l.Translate("Ammo supplied: " + str(scc["supplies"])))
		except: menuStats.addoption("supplies", l.Translate("Ammo supplied: 0"))
	if p.Class.Actions.CanPlant():
		try: menuStats.addoption("plants", l.Translate("Bombs planted: " + str(scc["plants"])))
		except: menuStats.addoption("plants", l.Translate("Bombs planted: 0"))
	if p.Class.Actions.CanExplode():
		try: menuStats.addoption("explodes", l.Translate("Bombs exploded: " + str(scc["explodes"])))
		except: menuStats.addoption("explodes", l.Translate("Bombs exploded: 0"))
	if p.Class.Actions.CanDefuse():
		try: menuStats.addoption("defuses", l.Translate("Bombs defused: " + str(scc["defuses"])))
		except: menuStats.addoption("defuses", l.Translate("Bombs defused: 0"))
	if p.Class.Actions.CanRescue():
		try: menuStats.addoption("rescues", l.Translate("Hostages rescued: " + str(scc["rescues"])))
		except: menuStats.addoption("rescues", l.Translate("Hostages rescued: 0"))
		
	menuStats.addoption(" ", " ")
	menuStats.addoption("save", l.Translate("->7. Save"))
		
''' Recreate the preferences menu '''
def updateMenuPreferences(player):
	l = player.Preferences.Language
	i = player.Preferences.InGameInfo
	#popuplib.delete("etMenuPreferences")
	#menuPreferences = popuplib.create("etMenuPreferences")
	menuPreferences.__init__("etMenuPreferences")
	menuPreferences.addline(l.Translate("[ETmod] Preferences"))
	menuPreferences.addline("-----------------------------")
	menuPreferences.addline(l.Translate("->1. Language"))
	menuPreferences.addline(l.Translate("->2. Display in game info: " + str(i)))
	menuPreferences.addline("-----------------------------")
	menuPreferences.addline(l.Translate("->0. Back"))
	menuPreferences.select(1, menuPreferencesHandler)
	menuPreferences.select(2, menuPreferencesHandler)
	menuPreferences.select(3, menuSendBack)
	menuPreferences.select(4, menuSendBack)
	menuPreferences.select(5, menuSendBack)
	menuPreferences.select(6, menuSendBack)
	menuPreferences.select(7, menuSendBack)
	menuPreferences.select(8, menuSendBack)
	menuPreferences.select(9, menuSendBack)
	menuPreferences.addline("-----------------------------")
	menuPreferences.submenu(10, "etMenuMain")
	
''' Recreate the help menu '''
def updateMenuHelp(player):
	l = player.Preferences.Language
	menuHelp.__init__("etMenuHelp")
	menuHelp.addline(l.Translate("[ETmod] Help"))
	menuHelp.addline("-----------------------------")
	menuHelp.addline(l.Translate("->1. Game rules"))
	menuHelp.addline(l.Translate("->2. Chat commands"))
	menuHelp.addline(l.Translate("->3. Console commands"))
	menuHelp.addline("-----------------------------")
	menuHelp.addline(l.Translate("->4. Classes configuration"))
	menuHelp.addline("-----------------------------")
	menuHelp.addline(l.Translate("->0. Back"))
	menuHelp.select(1, menuHelpHandler)
	menuHelp.select(2, menuHelpHandler)
	menuHelp.select(3, menuHelpHandler)
	menuHelp.select(4, menuHelpHandler)
	menuHelp.select(5, menuSendBack)
	menuHelp.select(6, menuSendBack)
	menuHelp.select(7, menuSendBack)
	menuHelp.select(8, menuSendBack)
	menuHelp.select(9, menuSendBack)
	menuHelp.submenu(10, "etMenuMain")
	
''' Recreate the about menu '''
def updateMenuAbout(player):
	l = player.Preferences.Language
	menuAbout.__init__("etMenuAbout")
	menuAbout.addline(l.Translate("[ETmod] About"))
	menuAbout.addline("-----------------------------")
	menuAbout.addline(" ")
	menuAbout.addline(l.Translate("ETmod2008 v0.1"))
	menuAbout.addline(l.Translate("Copyright McFly 2008"))
	menuAbout.addline(" ")
	menuAbout.addline("-----------------------------")
	menuAbout.addline(l.Translate("->0. Back"))
	menuAbout.select(1, menuSendBack)
	menuAbout.select(2, menuSendBack)
	menuAbout.select(3, menuSendBack)
	menuAbout.select(4, menuSendBack)
	menuAbout.select(5, menuSendBack)
	menuAbout.select(6, menuSendBack)
	menuAbout.select(7, menuSendBack)
	menuAbout.select(8, menuSendBack)
	menuAbout.select(9, menuSendBack)
	menuAbout.submenu(10, "etMenuMain")

''' Recreate the language selection menu '''
def updateMenuChooseLanguage(player):
	l = player.Preferences.Language
	#popuplib.delete("etMenuChooseLanguage")
	#menuChooseLanguage = popuplib.easymenu("etMenuChooseLanguage", "", menuChooseLanguageHandler)
	menuChooseLanguage.__init__("etMenuChooseLanguage", "", menuChooseLanguageHandler)
	menuChooseLanguage.settitle(l.Translate("[ETmod] Choose your language"))
	menuChooseLanguage.submenu(10, "etMenuMain")
	for l in languages.values():
		menuChooseLanguage.addoption(l.Name, l.Translate(l.Name.capitalize()))
		
''' Recreate the admin menu '''
def updateMenuAdmin(player):
	l = player.Preferences.Language
	menuAdmin.__init__("etMenuAdmin")
	menuAdmin.addline(l.Translate("[ETmod] Admin menu"))
	menuAdmin.addline("-----------------------------")
	menuAdmin.addline(l.Translate("->1. Mod configuration"))
	menuAdmin.addline(l.Translate("->2. Server configuration"))
	menuAdmin.addline(l.Translate("->3. Players management"))
	menuAdmin.addline(l.Translate("->4. Stats management"))
	menuAdmin.addline(l.Translate("->5. Skills management"))
	menuAdmin.addline(l.Translate("->6. Mod commands"))
	menuAdmin.addline(l.Translate("->7. Other functionalities"))
	menuAdmin.addline("-----------------------------")
	menuAdmin.addline(l.Translate("->0. Back"))
	menuAdmin.select(1, menuAdminHandler)
	menuAdmin.select(2, menuAdminHandler)
	menuAdmin.select(3, menuAdminHandler)
	menuAdmin.select(4, menuAdminHandler)
	menuAdmin.select(5, menuAdminHandler)
	menuAdmin.select(6, menuAdminHandler)
	menuAdmin.select(7, menuAdminHandler)
	menuAdmin.select(8, menuSendBack)
	menuAdmin.select(9, menuSendBack)
	menuAdmin.submenu(10, "etMenuMain")
		
''' Recreate mod configuration menu '''
def updateMenuModConfig(player):
	l = player.Preferences.Language
	menuModConfig.__init__("etMenuModConfig", "", menuModConfigHandler)
	menuModConfig.settitle(l.Translate("[ETmod] Mod configuration"))
	menuModConfig.addoption("et_restrict_classes", l.Translate("Restrict classes: " + str(es.getInt("et_restrict_classes") == 1)))
	menuModConfig.addoption("et_restrict_players_in_classes", l.Translate("Restrict players in classes: " + str(es.getInt("et_restrict_players_in_classes") == 1)))
	menuModConfig.addoption("et_no_reload", l.Translate("No reload for guns: " + str(es.getInt("et_no_reload") == 1)))
	menuModConfig.addoption("et_unlimited_ammo", l.Translate("Unimited ammo: " + str(es.getInt("et_unlimited_ammo") == 1)))
	menuModConfig.addoption("et_spawn_delay", l.Translate("Spawn delay: " + es.getString("et_spawn_delay")))
	menuModConfig.addoption("et_spawn_protection_time", l.Translate("Spawn protection time: " + es.getString("et_spawn_protection_time")))
	menuModConfig.addoption("et_synchronized_spawn", l.Translate("Synchronized spawn: " + str(es.getInt("et_synchronized_spawn") == 1)))
	menuModConfig.addoption("et_random_classes", l.Translate("Random classes: " + str(es.getInt("et_random_classes") == 1)))
	menuModConfig.addoption("et_use_colors", l.Translate("Use class colors on players: " + str(es.getInt("et_use_colors") == 1)))
	menuModConfig.addoption("et_round_xp", l.Translate("Xp given to players winning a round: " + es.getString("et_round_xp")))
	menuModConfig.addoption("et_round_money", l.Translate("Money given to players winning a round: " + es.getString("et_round_money")))
	menuModConfig.addoption("et_hurt_lose_xp", l.Translate("Players hurt will lose Xp: " + str(es.getInt("et_hurt_lose_xp") == 1)))
	menuModConfig.addoption("et_noconfig_map_behaviour", l.Translate("How to configure map without config: " + es.getString("et_noconfig_map_behaviour")))
	menuModConfig.submenu(10, "etMenuAdmin")
	
''' Recreate mod applying configuration menu '''
def updateMenuModApplyConfig(player):
	l = player.Preferences.Language
	menuModApplyConfig.__init__("etMenuModApplyConfig")
	menuModApplyConfig.addline(l.Translate("[ETmod] Apply config"))
	menuModApplyConfig.addline("-----------------------------")
	menuModApplyConfig.addline(l.Translate("->1. Apply now only"))
	menuModApplyConfig.addline(l.Translate("->2. Apply now and save for this map"))
	menuModApplyConfig.addline(l.Translate("->3. Apply now and save for all maps"))
	menuModApplyConfig.select(1, menuModApplyConfigHandler)
	menuModApplyConfig.select(2, menuModApplyConfigHandler)
	menuModApplyConfig.select(3, menuModApplyConfigHandler)
	menuModApplyConfig.select(4, menuSendBack)
	menuModApplyConfig.select(5, menuSendBack)
	menuModApplyConfig.select(6, menuSendBack)
	menuModApplyConfig.select(7, menuSendBack)
	menuModApplyConfig.select(8, menuSendBack)
	menuModApplyConfig.select(9, menuSendBack)
	menuModApplyConfig.submenu(10, "etMenuModApplyConfig")
	
''' Recreate server configuration menu '''
def updateMenuServerConfig(player):
	l = player.Preferences.Language
	menuServerConfig.__init__("etMenuServerConfig", "", menuServerConfigHandler)
	menuServerConfig.settitle(l.Translate("[ETmod] Server configuration"))
	menuServerConfig.addoption("hostname", l.Translate("Hostname: " + es.getString("hostname")))
	menuServerConfig.addoption("bot_quota", l.Translate("Bot quota: " + es.getString("bot_quota")))
	menuServerConfig.addoption("bot_quota_mode", l.Translate("Bot quota mode: " + es.getString("bot_quota_mode")))
	menuServerConfig.addoption("bot_join_after_player", l.Translate("Bot join after player: " + str(es.getInt("bot_join_after_player") == 1)))
	menuServerConfig.addoption("bot_join_team", l.Translate("Bot join team: " + es.getString("bot_join_team")))
	menuServerConfig.addoption("bot_join_delay", l.Translate("Bot join delay: " + es.getString("bot_join_delay")))
	menuServerConfig.addoption("mp_autoteambalance", l.Translate("Auto team balance: " + str(es.getInt("mp_autoteambalance") == 1)))
	menuServerConfig.addoption("mp_friendlyfire", l.Translate("Friendly-fire: " + str(es.getInt("mp_friendlyfire") == 1)))
	menuServerConfig.addoption("mp_c4timer", l.Translate("C4 timer: " + es.getString("mp_c4timer")))
	menuServerConfig.addoption("mp_chattime", l.Translate("Chat time: " + es.getString("mp_chattime")))
	menuServerConfig.addoption("mp_fadetoblack", l.Translate("Fade to black: " + str(es.getInt("mp_fadetoblack") == 1)))
	menuServerConfig.addoption("mp_flashlight", l.Translate("Flashlight: " + str(es.getInt("mp_flashlight") == 1)))
	menuServerConfig.addoption("mp_footsteps", l.Translate("Foot steps: " + str(es.getInt("mp_footsteps") == 1)))
	menuServerConfig.addoption("mp_freezetime", l.Translate("Freeze time: " + es.getString("mp_freezetime")))
	menuServerConfig.addoption("mp_maxrounds", l.Translate("Max rounds: " + es.getString("mp_maxrounds")))
	menuServerConfig.addoption("mp_roundtime", l.Translate("Round time: " + es.getString("mp_roundtime")))
	menuServerConfig.addoption("mp_timelimit", l.Translate("Time limit: " + es.getString("mp_timelimit")))
	menuServerConfig.addoption("mp_tkpunish", l.Translate("TK punishments: " + str(es.getInt("mp_tkpunish") == 1)))
	menuServerConfig.addoption("mp_winlimit", l.Translate("Win limit: " + es.getString("mp_winlimit")))
	menuServerConfig.submenu(10, "etMenuAdmin")
	
''' Recreate server applying configuration menu '''
def updateMenuServerApplyConfig(player):
	l = player.Preferences.Language
	menuServerApplyConfig.__init__("etMenuServerApplyConfig")
	menuServerApplyConfig.addline(l.Translate("[ETmod] Apply config"))
	menuServerApplyConfig.addline("-----------------------------")
	menuServerApplyConfig.addline(l.Translate("->1. Apply now only"))
	menuServerApplyConfig.addline(l.Translate("->2. Apply now and save for this map"))
	menuServerApplyConfig.addline(l.Translate("->3. Apply now and save for all maps"))
	menuServerApplyConfig.select(1, menuServerApplyConfigHandler)
	menuServerApplyConfig.select(2, menuServerApplyConfigHandler)
	menuServerApplyConfig.select(3, menuServerApplyConfigHandler)
	menuServerApplyConfig.select(4, menuSendBack)
	menuServerApplyConfig.select(5, menuSendBack)
	menuServerApplyConfig.select(6, menuSendBack)
	menuServerApplyConfig.select(7, menuSendBack)
	menuServerApplyConfig.select(8, menuSendBack)
	menuServerApplyConfig.select(9, menuSendBack)
	menuServerApplyConfig.submenu(10, "etMenuServerApplyConfig")
	
''' Recreate mod commands menu '''
def updateMenuModCommands(player):
	l = player.Preferences.Language
	menuModCommands.__init__("etMenuModCommands", "", menuModCommandsHandler)
	menuModCommands.settitle(l.Translate("[ETmod] Mod commands"))
	menuModCommands.addoption("et_players", l.Translate("Show players info in server console"))
	menuModCommands.addoption("et_classes", l.Translate("Show classes info in server console"))
	menuModCommands.addoption("et_skills", l.Translate("Show skills info in server console"))
	menuModCommands.addoption("et_saveall", l.Translate("Save players stats, preferences and skills"))
	menuModCommands.addoption("et_shutdown", l.Translate("Save players info and shut server down"))
	menuModCommands.submenu(10, "etMenuAdmin")
	
''' Recreate player selection menu '''
def updateMenuChoosePlayer1(player):
	l = player.Preferences.Language
	menuChoosePlayer1.__init__("etMenuChoosePlayer1", "", menuChoosePlayer1Handler)
	menuChoosePlayer1.settitle(l.Translate("[ETmod] Choose a player"))
	for p in players.values():
		menuChoosePlayer1.addoption(p.ID, p.Name + " (" + p.SteamID + ")")
	menuChoosePlayer1.submenu(10, "etMenuAdmin")
	
''' Recreate player selection menu '''
def updateMenuChoosePlayer2(player):
	l = player.Preferences.Language
	menuChoosePlayer2.__init__("etMenuChoosePlayer2", "", menuChoosePlayer2Handler)
	menuChoosePlayer2.settitle(l.Translate("[ETmod] Choose a player"))
	for p in players.values():
		if not p.IsBot():
			menuChoosePlayer1.addoption(p.ID, p.Name + " (" + p.SteamID + ")")
	menuChoosePlayer2.submenu(10, "etMenuAdmin")
	
''' Recreate player selection menu '''
def updateMenuChoosePlayer3(player):
	l = player.Preferences.Language
	menuChoosePlayer3.__init__("etMenuChoosePlayer3", "", menuChoosePlayer3Handler)
	menuChoosePlayer3.settitle(l.Translate("[ETmod] Choose a player"))
	for p in players.values():
		if not p.IsBot():
			menuChoosePlayer1.addoption(p.ID, p.Name + " (" + p.SteamID + ")")
	menuChoosePlayer3.submenu(10, "etMenuAdmin")
	
''' Recreate player management menu '''
def updateMenuPlayerManagement(player):
	l = player.Preferences.Language
	menuPlayerManagement.__init__("etMenuPlayerManagement", "", menuPlayerManagementHandler)
	menuPlayerManagement.settitle(l.Translate("[ETmod] Player management"))
	menuPlayerManagement.addoption("slap", l.Translate("Slap"))
	menuPlayerManagement.addoption("burn", l.Translate("Burn"))
	menuPlayerManagement.addoption("slay", l.Translate("Slay"))
	menuPlayerManagement.addoption("freeze", l.Translate("Freeze"))
	menuPlayerManagement.addoption("unfreeze", l.Translate("Unfreeze"))
	menuPlayerManagement.addoption("spec", l.Translate("Move to spectators"))
	menuPlayerManagement.addoption("switch", l.Translate("Switch team"))
	menuPlayerManagement.addoption("stuck", l.Translate("Stuck in the floor"))
	menuPlayerManagement.addoption("unstuck", l.Translate("Back on the floor"))
	menuPlayerManagement.addoption("kick", l.Translate("Kick"))
	menuPlayerManagement.addoption("ban", l.Translate("Ban"))
	menuPlayerManagement.addoption("noclass", l.Translate("Set class as 'no class'"))
	menuPlayerManagement.addoption("class", l.Translate("Change class"))
	menuPlayerManagement.addoption("remwep", l.Translate("Remove weapons"))
	menuPlayerManagement.addoption("poison", l.Translate("Poison"))
	menuPlayerManagement.addoption("spawn", l.Translate("Respawn"))
	menuPlayerManagement.submenu(10, "etMenuAdmin")
	
''' Recreate stats management menu '''
def updateMenuStatsManagement(player):
	l = player.Preferences.Language
	menuStatsManagement.__init__("etMenuStatsManagement", "", menuStatsManagementHandler)
	menuStatsManagement.settitle(l.Translate("[ETmod] Stats management"))
	menuStatsManagement.addoption("xp+", l.Translate("More Xp"))
	menuStatsManagement.addoption("xp-", l.Translate("Less Xp"))
	menuStatsManagement.addoption("money+", l.Translate("More money"))
	menuStatsManagement.addoption("money-", l.Translate("Less money"))
	menuStatsManagement.addoption("level+", l.Translate("Level up"))
	menuStatsManagement.addoption("level-", l.Translate("Level down"))
	menuStatsManagement.submenu(10, "etMenuAdmin")
	
''' Recreate skills management menu '''
def updateMenuSkillsManagement(player):
	l = player.Preferences.Language
	menuSkillsManagement.__init__("etMenuSkillsManagement", "", menuSkillsManagementHandler)
	menuSkillsManagement.settitle(l.Translate("[ETmod] Skills management"))
	menuSkillsManagement.submenu(10, "etMenuAdmin")
	
''' Recreate other functionalities menu '''
def updateMenuOtherFunctionalities(player):
	l = player.Preferences.Language
	menuOtherFunctionalities.__init__("etMenuOtherFunctionalities", "", menuOtherFunctionalitiesHandler)
	menuOtherFunctionalities.settitle(l.Translate("[ETmod] Other functionalities"))
	menuOtherFunctionalities.submenu(10, "etMenuAdmin")
	
''' Recreate the rules menu '''
def updateMenuRules(player):
	l = player.Preferences.Language
	menuRules.__init__("etMenuRules", "", menuRulesHandler)
	menuRules.settitle(l.Translate("[ETmod] Game rules"))
	menuRules.c_stateformat[False] = "(%2)"
	menuRules.c_stateformat[True] = "%2"
	menuRules.addoption(" ", l.Translate("On a normal map the gameplay won't look"))
	menuRules.addoption(" ", l.Translate("very different then usual at first sight."))
	menuRules.addoption(" ", l.Translate("However after playing some time you will"))
	menuRules.addoption(" ", l.Translate("quickly notice how much different it is !"))
	menuRules.addoption(" ", l.Translate(" "))
	menuRules.addoption(" ", l.Translate("On DE maps terrorists still have to plant"))
	menuRules.addoption(" ", l.Translate("bombs and counter-terrorists to defuse them"))
	menuRules.addoption(" ", l.Translate("while on CS maps counter-terrorists must"))
	menuRules.addoption(" ", l.Translate("rescue the hostages. However here you must"))
	menuRules.addoption(" ", l.Translate("choose a class from the mod to play. Each"))
	menuRules.addoption(" ", l.Translate("of those classes have different parameters"))
	menuRules.addoption(" ", l.Translate("and some of them define the actions they"))
	menuRules.addoption(" ", l.Translate("can do. Only some classes will be allowed"))
	menuRules.addoption(" ", l.Translate("to plant or defuse bombs and to rescue"))
	menuRules.addoption(" ", l.Translate("hostages."))
	menuRules.addoption(" ", l.Translate("But the possible gameplay actions are not"))
	menuRules.addoption(" ", l.Translate("limited to that in this mod. Actually some"))
	menuRules.addoption(" ", l.Translate("classes will be able to heal their teammates"))
	menuRules.addoption(" ", l.Translate("or themselves and some others to supply ammo."))
	menuRules.addoption(" ", l.Translate(" "))
	menuRules.addoption(" ", l.Translate("Each possible action of the game will make you"))
	menuRules.addoption(" ", l.Translate("earn or lose money and Xp. With Xp you'll need"))
	menuRules.addoption(" ", l.Translate("to reach a certain level to unlock this or that."))
	menuRules.addoption(" ", l.Translate("There are different things that can be unlocked."))
	menuRules.addoption(" ", l.Translate("Also it can be useful to remember that a quite"))
	menuRules.addoption(" ", l.Translate("important amount of Xp will be given to all"))
	menuRules.addoption(" ", l.Translate("players winning a round."))
	menuRules.addoption(" ", l.Translate(" "))
	menuRules.addoption(" ", l.Translate("First of all some classes will be available only"))
	menuRules.addoption(" ", l.Translate("once you'll have reached a certain level in another"))
	menuRules.addoption(" ", l.Translate("class. The second thing is that players can learn"))
	menuRules.addoption(" ", l.Translate("skills once their level will be high enough."))
	menuRules.addoption(" ", l.Translate(" "))
	menuRules.addoption(" ", l.Translate("As you will notice when checking the buy menu"))
	menuRules.addoption(" ", l.Translate("there are many different skills you can learn."))
	menuRules.addoption(" ", l.Translate("But they are usaully limited to some classes."))
	menuRules.addoption(" ", l.Translate("Once you have a level high enough you'll be able"))
	menuRules.addoption(" ", l.Translate("to learn the skill you want."))
	menuRules.addoption(" ", l.Translate("Another important thing to notice is that skills"))
	menuRules.addoption(" ", l.Translate("can be updated at any time. For that you will just"))
	menuRules.addoption(" ", l.Translate("need money. Once you'll open your skill upgrading"))
	menuRules.addoption(" ", l.Translate("menu from within the buy menu you'll see what"))
	menuRules.addoption(" ", l.Translate("parameters can be upgraded."))
	menuRules.addoption(" ", l.Translate("Also each time you'll want to use one of your skills"))
	menuRules.addoption(" ", l.Translate("you'll have to buy a new instance of it. But if"))
	menuRules.addoption(" ", l.Translate("you can afford it you can of course buy multiple"))
	menuRules.addoption(" ", l.Translate("of them at once."))
	menuRules.addoption(" ", l.Translate(" "))
	menuRules.addoption(" ", l.Translate("Each of the different possible game actions can"))
	menuRules.addoption(" ", l.Translate("be executed with either a chat or a console command."))
	menuRules.addoption(" ", l.Translate("Binding the console command to a key will make it"))
	menuRules.addoption(" ", l.Translate("very easy to use. Those commands are described in the"))
	menuRules.addoption(" ", l.Translate("menu related to them."))
	menuRules.addoption(" ", l.Translate(" "))
	menuRules.submenu(10, "etMenuHelp")
	
''' Recreate the chat commands menu '''
def updateMenuChatCommands(player):
	l = player.Preferences.Language
	menuChatCommands.__init__("etMenuChatCommands", "", menuChatCommandsHandler)
	menuChatCommands.settitle(l.Translate("[ETmod] Chat commands"))
	menuChatCommands.c_stateformat[False] = "(%2)"
	menuChatCommands.c_stateformat[True] = "%2"
	menuChatCommands.addoption("info", l.Translate("These are all the commands"))
	menuChatCommands.addoption("info", l.Translate("that you can type in the chat:"))
	menuChatCommands.addoption("info", l.Translate(" "))
	menuChatCommands.addoption("etmenu", l.Translate("- etmenu: open the main menu"))
	menuChatCommands.addoption("etspawn", l.Translate("- etspawn: respawn if you're allowed to"))
	menuChatCommands.addoption("etclass", l.Translate("- etclass [<classname>]: choose a class"))
	menuChatCommands.addoption("etclass", l.Translate("   for now or your next respawn"))
	menuChatCommands.addoption("etlevel", l.Translate("- etlevel [<classname>]: display your curent"))
	menuChatCommands.addoption("etlevel", l.Translate("   level and xp"))
	menuChatCommands.addoption("etheal", l.Translate("- etheal: used to heal"))
	menuChatCommands.addoption("etheal", l.Translate("   yourself and teammates"))
	menuChatCommands.addoption("etsupply", l.Translate("- etsupply: used to supply ammo"))
	menuChatCommands.addoption("etsupply", l.Translate("   to yourself and teammates"))
	menuChatCommands.addoption("etswitchwep", l.Translate("- etswitchwep: to switch between"))
	menuChatCommands.addoption("etswitchwep", l.Translate("   old and new weapons"))
	menuChatCommands.addoption("etmenuclass", l.Translate("- etmenuclass: shortcut to the"))
	menuChatCommands.addoption("etmenuclass", l.Translate("   class selection menu"))
	menuChatCommands.addoption("etmenustats", l.Translate("- etmenustats: shortcut to the"))
	menuChatCommands.addoption("etmenustats", l.Translate("   stats displaying menu"))
	menuChatCommands.addoption("etmenupref", l.Translate("- etmenupref: shortcut to the"))
	menuChatCommands.addoption("etmenupref", l.Translate("   user preferences menu"))
	menuChatCommands.submenu(10, "etMenuHelp")
	
''' Recreate the console commands menu '''
def updateMenuConsoleCommands(player):
	l = player.Preferences.Language
	menuConsoleCommands.__init__("etMenuConsoleCommands", "", menuConsoleCommandsHandler)
	menuConsoleCommands.settitle(l.Translate("[ETmod] Console commands"))
	menuConsoleCommands.c_stateformat[False] = "(%2)"
	menuConsoleCommands.c_stateformat[True] = "%2"
	menuConsoleCommands.addoption("info", l.Translate("These are all the commands"))
	menuConsoleCommands.addoption("info", l.Translate("that you can type in your console:"))
	menuConsoleCommands.addoption("info", l.Translate(" "))
	menuConsoleCommands.addoption("et_menu", l.Translate("- etmenu: open the main menu"))
	menuConsoleCommands.addoption("et_spawn", l.Translate("- etspawn: respawn if you're allowed to"))
	menuConsoleCommands.addoption("et_class", l.Translate("- etclass [<classname>]: choose a class"))
	menuConsoleCommands.addoption("et_class", l.Translate("   for now or your next respawn"))
	menuConsoleCommands.addoption("et_heal", l.Translate("- etheal: used to heal"))
	menuConsoleCommands.addoption("et_heal", l.Translate("   yourself and teammates"))
	menuConsoleCommands.addoption("et_supply", l.Translate("- etsupply: used to supply ammo"))
	menuConsoleCommands.addoption("et_supply", l.Translate("   to yourself and teammates"))
	menuConsoleCommands.addoption("et_switchwep", l.Translate("- et_switchwep: to switch between"))
	menuConsoleCommands.addoption("et_switchwep", l.Translate("   old and new weapons"))
	menuConsoleCommands.addoption("et_menu_class", l.Translate("- etmenuclass: shortcut to the"))
	menuConsoleCommands.addoption("et_menu_class", l.Translate("   class selection menu"))
	menuConsoleCommands.addoption("et_menu_stats", l.Translate("- etmenustats: shortcut to the"))
	menuConsoleCommands.addoption("et_menu_stats", l.Translate("   stats displaying menu"))
	menuConsoleCommands.addoption("et_menu_pref", l.Translate("- etmenupref: shortcut to the"))
	menuConsoleCommands.addoption("et_menu_pref", l.Translate("   user preferences menu"))
	menuConsoleCommands.submenu(10, "etMenuHelp")
	
''' Recreate the classes config info menu '''
def updateMenuClassesInfo(player):
	l = player.Preferences.Language
	menuClassesInfo.__init__("etMenuClassesInfo", "", menuClassesInfoHandler)
	menuClassesInfo.settitle(l.Translate("[ETmod] Choose a class"))
	menuClassesInfo.submenu(10, "etMenuHelp")
	for c in classes.keys():
		menuClassesInfo.addoption(c, l.Translate(c))
		
''' Recreate the class config info menu '''
def updateMenuClassInfo(player):
	l = player.Preferences.Language
	c = classes[player.Situation.Page]
	menuClassInfo.__init__("etMenuClassInfo", "", menuClassInfoHandler)
	menuClassInfo.settitle(l.Translate("[ETmod] Class configuration"))
	menuClassInfo.c_stateformat[False] = "(%2)"
	menuClassInfo.c_stateformat[True] = "%2"
	menuClassInfo.addoption(" ", l.Translate("->1 Locks:"))
	menuClassInfo.addoption(" ", l.Translate("  -To unlock: reach level " + str(c.UnlockLevel) + " in class " + c.UnlockClass))
	menuClassInfo.addoption(" ", l.Translate("  -Max players allowed at once: " + str(c.MaxAllowed) + "%"))
	menuClassInfo.addoption(" ", l.Translate("->2 Specs:"))
	menuClassInfo.addoption(" ", l.Translate("  -Health: " + str(c.Health)))
	menuClassInfo.addoption(" ", l.Translate("  -Armor: " + str(c.Armor)))
	menuClassInfo.addoption(" ", l.Translate("  -Speed: " + str(c.Speed)))
	menuClassInfo.addoption(" ", l.Translate("  -Color: " + str(c.Color)))
	menuClassInfo.addoption(" ", l.Translate("->3 Weapons:"))
	try: menuClassInfo.addoption(" ", l.Translate("  -Primary weapon for Ts: " + str(c.WeaponPrimaryT)))
	except: menuClassInfo.addoption(" ", l.Translate("  -Primary weapon for Ts: /"))
	try: menuClassInfo.addoption(" ", l.Translate("  -Primary weapon for CTs: " + str(c.WeaponPrimaryCT)))
	except: menuClassInfo.addoption(" ", l.Translate("  -Primary weapon for CTs: /"))
	try: menuClassInfo.addoption(" ", l.Translate("  -Secondary weapon for Ts: " + str(c.WeaponSecondaryT)))
	except: menuClassInfo.addoption(" ", l.Translate("  -Secondary weapon for Ts: /"))
	try: menuClassInfo.addoption(" ", l.Translate("  -Secondary weapon for CTs: " + str(c.WeaponSecondaryCT)))
	except: menuClassInfo.addoption(" ", l.Translate("  -Secondary weapon for CTs: /"))
	try: menuClassInfo.addoption(" ", l.Translate("  -Inventory for Ts: " + str(c.InventoryT)))
	except: menuClassInfo.addoption(" ", l.Translate("  -Inventory for Ts: /"))
	try: menuClassInfo.addoption(" ", l.Translate("  -Inventory for CTs: " + str(c.InventoryCT)))
	except: menuClassInfo.addoption(" ", l.Translate("  -Inventory for CTs: /"))
	try: menuClassInfo.addoption(" ", l.Translate("  -Bonus weapon for Ts: " + str(c.Upgrades.BetterWeaponT)))
	except: menuClassInfo.addoption(" ", l.Translate("  -Bonus weapon for Ts: /"))
	try: menuClassInfo.addoption(" ", l.Translate("  -Bonus weapon for CTs: " + str(c.Upgrades.BetterWeaponCT)))
	except: menuClassInfo.addoption(" ", l.Translate("  -Bonus weapon for CTs: /"))
	menuClassInfo.addoption(" ", l.Translate("->4 Ammo:"))
	if c.WeaponPrimaryT is not None: menuClassInfo.addoption(" ", l.Translate("  -Primary ammo for Ts: " + str(c.AmmoPrimaryT)))
	if c.WeaponPrimaryCT is not None: menuClassInfo.addoption(" ", l.Translate("  -Primary ammo for CTs: " + str(c.AmmoPrimaryCT)))
	if c.WeaponSecondaryT is not None: menuClassInfo.addoption(" ", l.Translate("  -Secondary ammo for Ts: " + str(c.AmmoSecondaryT)))
	if c.WeaponSecondaryCT is not None: menuClassInfo.addoption(" ", l.Translate("  -Secondary ammo for CTs: " + str(c.AmmoSecondaryCT)))
	if c.WeaponPrimaryT is not None: menuClassInfo.addoption(" ", l.Translate("  -Primary clip size for Ts: " + str(c.ClipPrimaryT)))
	if c.WeaponPrimaryCT is not None: menuClassInfo.addoption(" ", l.Translate("  -Primary clip size for CTs: " + str(c.ClipPrimaryCT)))
	if c.WeaponSecondaryT is not None: menuClassInfo.addoption(" ", l.Translate("  -Secondary clip size for Ts: " + str(c.ClipSecondaryT)))
	if c.WeaponSecondaryCT is not None: menuClassInfo.addoption(" ", l.Translate("  -Secondary clip size for CTs: " + str(c.ClipSecondaryCT)))
	if c.InventoryT is not None: menuClassInfo.addoption(" ", l.Translate("  -Inventory amount for Ts: " + str(c.InvAmountT)))
	if c.InventoryCT is not None: menuClassInfo.addoption(" ", l.Translate("  -Inventory amount for CTs: " + str(c.InvAmountCT)))
	menuClassInfo.addoption(" ", l.Translate("->5 Actions:"))
	menuClassInfo.addoption(" ", l.Translate("  -Kill: +" + str(c.Actions.KillXp) + "xp (+$" + str(c.Actions.KillMoney) + ")"))
	menuClassInfo.addoption(" ", l.Translate("  -Feath: -" + str(c.Actions.DeathXp) + "xp (-$" + str(c.Actions.DeathMoney) + ")"))
	menuClassInfo.addoption(" ", l.Translate("  -Suicide: -" + str(c.Actions.SuicideXp) + "xp (-$" + str(c.Actions.SuicideMoney) + ")"))
	menuClassInfo.addoption(" ", l.Translate("  -Team-kill: -" + str(c.Actions.TeamKillXp) + "xp (-$" + str(c.Actions.TeamKillMoney) + ")"))
	menuClassInfo.addoption(" ", l.Translate("  -Headshot: +" + str(c.Actions.HeadshotXp) + "xp (+$" + str(c.Actions.HeadshotMoney) + ")"))
	menuClassInfo.addoption(" ", l.Translate("  -Knife kill: +" + str(c.Actions.KnifeXp) + "xp (+$" + str(c.Actions.KnifeMoney) + ")"))
	menuClassInfo.addoption(" ", l.Translate("  -Hurt: +" + str(c.Actions.HurtXp) + "xp (+$" + str(c.Actions.HurtMoney) + ")"))
	menuClassInfo.addoption(" ", l.Translate("  -Self-hurt: -" + str(c.Actions.SelfHurtXp) + "xp (-$" + str(c.Actions.SelfHurtMoney) + ")"))
	menuClassInfo.addoption(" ", l.Translate("  -Team-hurt: -" + str(c.Actions.TeamHurtXp) + "xp (-$" + str(c.Actions.TeamHurtMoney) + ")"))
	if c.Actions.CanPlant(): menuClassInfo.addoption(" ", l.Translate("  -Plant bomb: +" + str(c.Actions.PlantXp) + "xp (+$" + str(c.Actions.PlantMoney) + ")"))
	if c.Actions.CanDefuse(): menuClassInfo.addoption(" ", l.Translate("  -Defuse bomb: +" + str(c.Actions.DefuseXp) + "xp (+$" + str(c.Actions.DefuseMoney) + ")"))
	if c.Actions.CanExplode(): menuClassInfo.addoption(" ", l.Translate("  -Explode bomb: +" + str(c.Actions.ExplodeXp) + "xp (+$" + str(c.Actions.ExplodeMoney) + ")"))
	if c.Actions.CanRescue(): menuClassInfo.addoption(" ", l.Translate("  -Rescue hostage: +" + str(c.Actions.RescueXp) + "xp (+$" + str(c.Actions.RescueMoney) + ")"))
	if c.Actions.CanHeal(): menuClassInfo.addoption(" ", l.Translate("  -Heal teammate: +" + str(c.Actions.HealXp) + "xp (+$" + str(c.Actions.HealMoney) + ")"))
	if c.Actions.CanSupply(): menuClassInfo.addoption(" ", l.Translate("  -Supply ammo: +" + str(c.Actions.SupplyXp) + "xp (+$" + str(c.Actions.SupplyMoney) + ")"))
	menuClassInfo.addoption(" ", l.Translate("->6 Available skills:"))
	for s in skills.values():
		if c in s.Classes:
			menuClassInfo.addoption(" ", l.Translate("  -" + s.Name.capitalize()))
	menuClassInfo.submenu(10, "etMenuHelp")
	
''' Recreate the buy menu '''
def updateMenuBuy(player):
	l = player.Preferences.Language
	menuBuy.__init__("etMenuBuy")
	menuBuy.addline(l.Translate("[ETmod] Buy stuff - Money: $" + str(player.Stats.Money)))
	menuBuy.addline("-----------------------------")
	menuBuy.addline(l.Translate("->1. Upgrade class"))
	menuBuy.addline(l.Translate("->2. Learn skills"))
	menuBuy.addline(l.Translate("->3. Armory"))
	menuBuy.addline("-----------------------------")
	menuBuy.addline(l.Translate("Bank:"))
	menuBuy.addline(l.Translate("*****"))
	menuBuy.addline(l.Translate("Saved money: $" + str(player.Stats.SavedMoney)))
	menuBuy.addline(l.Translate("->4. Store"))
	menuBuy.addline(l.Translate("->5. Retreive"))
	menuBuy.addline("-----------------------------")
	menuBuy.addline(l.Translate("->0. Back"))
	menuBuy.select(1, menuBuyHandler)
	menuBuy.select(2, menuBuyHandler)
	menuBuy.select(3, menuBuyHandler)
	menuBuy.select(4, menuBuyHandler)
	menuBuy.select(5, menuBuyHandler)
	menuBuy.select(6, menuSendBack)
	menuBuy.select(7, menuSendBack)
	menuBuy.select(8, menuSendBack)
	menuBuy.select(9, menuSendBack)
	menuBuy.submenu(10, "etMenuMain")
	
''' Recreate the class upgrading menu '''
def updateMenuUpgradeClass(player):
	# Get info
	l = player.Preferences.Language
	c = player.Class
	u = player.Class.Upgrades
	s = player.Stats
	b = player.BoughtStuff
	
	menuUpgradeClass.__init__("etMenuUpgradeClass", "", menuUpgradeClassHandler)
	menuUpgradeClass.settitle(l.Translate("[ETmod] Upgrade your class '" + c.Name + "' - Money: $" + str(s.Money)))
	menuUpgradeClass.addoption("health", l.Translate("Buy health point: $" +\
		str(u.CurrentPrice(u.HealthPrice, s.GetLevel(c.Name), b.Classes[c.Name]["health"])) +\
		" (" + str(b.Classes[c.Name]["health"]) + ")"))
	menuUpgradeClass.addoption("armor", l.Translate("Buy armor point: $" +\
		str(u.CurrentPrice(u.ArmorPrice, s.GetLevel(c.Name), b.Classes[c.Name]["armor"])) +\
		" (" + str(b.Classes[c.Name]["armor"]) + ")"))
	menuUpgradeClass.addoption("speed", l.Translate("Buy speed point: $" +\
		str(u.CurrentPrice(u.SpeedPrice, s.GetLevel(c.Name), b.Classes[c.Name]["speed"])) +\
		" (" + str(b.Classes[c.Name]["speed"]) + ")"))
	if player.Class.Actions.CanHeal():
		menuUpgradeClass.addoption("heal", l.Translate("Heal faster: coming soon..."))
	if player.Class.Actions.CanSupply():
		menuUpgradeClass.addoption("supply", l.Translate("Supply ammo faster: coming soon..."))
	menuUpgradeClass.submenu(10, "etMenuBuy")
	
''' Recreate the skills learning menu '''
def updateMenuLearnSkills(player):
	# Get info	
	l = player.Preferences.Language
	
	# Update menu
	menuLearnSkills.__init__("etMenuLearnSkills", "", menuLearnSkillsHandler)
	menuLearnSkills.settitle(l.Translate("[ETmod] Learn new skills"))
	for s in skills.values():
		if player.Class in s.Classes:
			menuLearnSkills.addoption(s.Name, l.Translate(s.Name.capitalize()))
	menuLearnSkills.submenu(10, "etMenuBuy")
	
''' Recreate the skill upgrading menu '''
def updateMenuUpgradeSkill(player):
	# Get info
	l = player.Preferences.Language
	ps = player.Situation.Selection
	s = ps.Skill
	c = player.Class
	stats = player.Stats
	
	# Update menu
	menuUpgradeSkill.__init__("etMenuUpgradeSkill", "", menuUpgradeSkillHandler)
	menuUpgradeSkill.settitle(l.Translate("[ETmod] Upgrade '" + s.Name + "' skill"))
	menuUpgradeSkill.c_stateformat[False] = "(%2)"
	menuUpgradeSkill.c_stateformat[True] = "%2"
	menuUpgradeSkill.addoption(" ", "Your money: $" + str(player.Stats.Money))
	menuUpgradeSkill.addoption(" ", " ")
	menuUpgradeSkill.addoption(" ", "Current amount: " + str(ps.Amount))
	menuUpgradeSkill.addoption("buy", "->4. Buy one instance: $" + str(s.CurrentPrice(1, stats.GetLevel(c.Name))))
	menuUpgradeSkill.addoption(" ", " ")
	menuUpgradeSkill.addoption(" ", " ")
	menuUpgradeSkill.addoption(" ", " ")
	for p in s.Parameters.values():
		menuUpgradeSkill.addoption(" ", "Your money: $" + str(player.Stats.Money))
		menuUpgradeSkill.addoption(" ", l.Translate(skillParameterNames[p.Type].capitalize()))
		menuUpgradeSkill.addoption(" ", "----------")
		menuUpgradeSkill.addoption(" ", l.Translate("Default value: " + str(p.Default)))
		try: menuUpgradeSkill.addoption(" ", l.Translate("Current value: " + str(ps.Progression[p.Type])))
		except: menuUpgradeSkill.addoption(" ", l.Translate("Current value: " + str(p.Default)))
		menuUpgradeSkill.addoption(" ", l.Translate("Maximum value: " + str(p.Max)))
		try: menuUpgradeSkill.addoption(p.Type, l.Translate("->7. Add " + str(p.Add) +": $" + str(p.CurrentPrice(ps.Progression[p.Type], stats.GetLevel(c.Name)))))
		except: menuUpgradeSkill.addoption(p.Type, l.Translate("->7. Add " + str(p.Add) +": $" + str(1, stats.GetLevel(c.Name))))
	menuUpgradeSkill.submenu(10, "etMenuBuy")
	
''' Recreate the armory menu '''
def updateMenuArmory(player):
	# Get info
	l = player.Preferences.Language
	c = player.Class
	u = player.Class.Upgrades
	s = player.Stats
	b = player.BoughtStuff
	
	menuArmory.__init__("etMenuArmory", "", menuArmoryHandler)
	menuArmory.settitle(l.Translate("[ETmod] Armory - Money: $" + str(s.Money)))
	
	#Show prices and required level
	if player.Team == 2:
		menuArmory.addoption("primammo", l.Translate("Buy additional T primary ammo: $" +\
			str(u.CurrentPrice(u.PrimaryAmmoPriceT, s.GetLevel(c.Name), b.Classes[c.Name]["primary_ammo_t"])) +\
			" (" + str(b.Classes[c.Name]["primary_ammo_t"]) + ")"))
		menuArmory.addoption("secammo", l.Translate("Buy additional T secondary ammo: $" +\
			str(u.CurrentPrice(u.SecondaryAmmoPriceT, s.GetLevel(c.Name), b.Classes[c.Name]["secondary_ammo_t"])) +\
			" (" + str(b.Classes[c.Name]["secondary_ammo_t"]) + ")"))
		if isinstance(c.InventoryT, Weapon) and not c.InventoryT.Class == weaponClasses["items"]:
			menuArmory.addoption("inventory", l.Translate("Buy an additional " + str(c.InventoryT) +\
				": $" + str(u.CurrentPrice(u.InventoryPriceT, s.GetLevel(c.Name), b.Classes[c.Name]["inv_amount_t"])) +\
				" (" + str(b.Classes[c.Name]["inv_amount_t"]) + ")"))
		if u.BetterWeaponT is not None:
			menuArmory.addoption("weapon", l.Translate("Buy better T weapon (" + str(u.BetterWeaponT) +\
				"): $" + str(u.CurrentPrice(u.BetterWeaponPriceT, s.GetLevel(c.Name), 1)) +\
				" (" + str(b.Classes[c.Name]["better_weapon_t"]) + ")"))
	elif player.Team == 3:
		menuArmory.addoption("primammo", l.Translate("Buy additional CT primary ammo: $" +\
			str(u.CurrentPrice(u.PrimaryAmmoPriceCT, s.GetLevel(c.Name), b.Classes[c.Name]["primary_ammo_ct"])) +\
			" (" + str(b.Classes[c.Name]["primary_ammo_ct"]) + ")"))
		menuArmory.addoption("secammo", l.Translate("Buy additional CT secondary ammo: $" +\
			str(u.CurrentPrice(u.SecondaryAmmoPriceCT, s.GetLevel(c.Name), b.Classes[c.Name]["secondary_ammo_ct"])) +\
			" (" + str(b.Classes[c.Name]["secondary_ammo_ct"]) + ")"))
		if isinstance(c.InventoryCT, Weapon) and not c.InventoryCT.Class == weaponClasses["items"]:
			menuArmory.addoption("inventory", l.Translate("Buy an additional " + str(c.InventoryCT) +\
				": $" + str(u.CurrentPrice(u.InventoryPriceCT, s.GetLevel(c.Name), b.Classes[c.Name]["inv_amount_ct"])) +\
				" (" + str(b.Classes[c.Name]["inv_amount_ct"]) + ")"))
		if u.BetterWeaponCT is not None:
			menuArmory.addoption("weapon", l.Translate("Buy better CT weapon (" + str(u.BetterWeaponCT) +\
				"): $" + str(u.CurrentPrice(u.BetterWeaponPriceCT, s.GetLevel(c.Name), 1)) +\
				" (" + str(b.Classes[c.Name]["better_weapon_ct"]) + ")"))
	menuArmory.submenu(10, "etMenuBuy")
	
''' Recreate the skill selection menu '''
def updateMenuChooseSkill(player):
	l = player.Preferences.Language
	menuChooseSkill.__init__("etMenuChooseSkill", "", menuChooseSkillHandler)
	menuChooseSkill.settitle(l.Translate("[ETmod] Your skills"))
	for ps in player.Skills.values():
		if player.Class in ps.Skill.Classes and ps.Amount > 0:
			menuChooseSkill.addoption(ps.Skill.Name, l.Translate(ps.Skill.Name.capitalize() + ": " + str(ps.Amount)))
	menuChooseSkill.submenu(10, "etMenuMain")
	
''' Recreate the quick stats displaying menu '''
def updateMenuQuickStats(player):
	l = player.Preferences.Language
	menuQuickStats.__init__("etMenuQuickStats")
	menuQuickStats.addline(l.Translate("[ETmod2008 by McFly] Quick stats"))
	menuQuickStats.addline("-----------------------------")
	menuQuickStats.addline(" ")
	menuQuickStats.addline(l.Translate("Money: " + str(player.Stats.Money)))
	menuQuickStats.addline(l.Translate("Class specific info"))
	menuQuickStats.addline(l.Translate("  Level: " + str(player.Stats.GetLevel(player.Class.Name))))
	menuQuickStats.addline(l.Translate("  Xp: " + str(player.Stats.Classes[player.Class.Name]["xp"])))
	menuQuickStats.addline("-----------------------------")
	menuQuickStats.addline(l.Translate("->9. Open main menu"))
	menuQuickStats.select(9, menuQuickStatsHandler)
	menuQuickStats.timeoutview = 5

#___________________________________________SHOW FUNCTIONS

# ------------------------- #
# SHOW FUNCTIONS #
# ------------------------- #		
''' Show main menu '''
def showMenuMain(player):
	updateMenuMain(players[player])
	popuplib.gPopups["etMenuMain"].send(player)
	
''' Show class selection menu '''
def showMenuChooseClass(player):
	updateMenuChooseClass(players[player])
	popuplib.gPopups["etMenuChooseClass"].send(player)
	
''' Show stats menu '''
def showMenuStats(player):
	updateMenuSelectClass(players[player])	
	popuplib.gPopups["etMenuSelectClass"].send(player)
	
''' Show player preferences menu '''
def showMenuPreferences(player):
	updateMenuPreferences(players[player])
	popuplib.gPopups["etMenuPreferences"].send(player)
	
''' Show language selection menu '''
def showMenuChooseLanguage(player):
	updateMenuChooseLanguage(players[player])
	popuplib.gPopups["etMenuChooseLanguage"].send(player)	
	
''' Show help menu '''
def showMenuHelp(player):
	updateMenuHelp(players[player])
	popuplib.gPopups["etMenuHelp"].send(player)
	
''' Show about menu '''
def showMenuAbout(player):
	updateMenuAbout(players[player])
	popuplib.gPopups["etMenuAbout"].send(player)
	
''' Show admin menu '''
def showMenuAdmin(player):
	updateMenuAdmin(players[player])
	popuplib.gPopups["etMenuAdmin"].send(player)
	
''' Show mod configuration menu '''
def showMenuModConfig(player):
	updateMenuModConfig(players[player])
	popuplib.gPopups["etMenuModConfig"].send(player)
	
''' Show mod config applying menu '''
def showMenuModApplyConfig(player):
	updateMenuModApplyConfig(players[player])
	popuplib.gPopups["etMenuModApplyConfig"].send(player)
	
''' Show server configuration menu '''
def showMenuServerConfig(player):
	updateMenuServerConfig(players[player])
	popuplib.gPopups["etMenuServerConfig"].send(player)
	
''' Show server config applying menu '''
def showMenuServerApplyConfig(player):
	updateMenuServerApplyConfig(players[player])
	popuplib.gPopups["etMenuServerApplyConfig"].send(player)
	
''' Show player selection menu for players management menu '''
def showMenuChoosePlayer1(player):
	updateMenuChoosePlayer1(players[player])
	popuplib.gPopups["etMenuChoosePlayer1"].send(player)
	
''' Show player selection menu for stats management menu '''
def showMenuChoosePlayer2(player):
	updateMenuChoosePlayer2(players[player])
	popuplib.gPopups["etMenuChoosePlayer2"].send(player)
	
''' Show player selection menu for skills configuration menu '''
def showMenuChoosePlayer3(player):
	updateMenuChoosePlayer3(players[player])
	popuplib.gPopups["etMenuChoosePlayer3"].send(player)
	
''' Show player management menu '''
def showMenuPlayerManagement(player):
	updateMenuPlayerManagement(players[player])
	popuplib.gPopups["etMenuPlayerManagement"].send(player)
	
''' Show stats management menu '''
def showMenuStatsManagement(player):
	updateMenuStatsManagement(players[player])
	popuplib.gPopups["etMenuStatsManagement"].send(player)
	
''' Show skills management menu '''
def showMenuSkillsManagement(player):
	updateMenuSkillsManagement(players[player])
	popuplib.gPopups["etMenuSkillsManagement"].send(player)
	
''' Show mod commands menu '''
def showMenuModCommands(player):
	updateMenuModCommands(players[player])
	popuplib.gPopups["etMenuModCommands"].send(player)
	
''' Show server configuration menu '''
def showMenuOtherFunctionalities(player):
	updateMenuOtherFunctionalities(players[player])
	popuplib.gPopups["etMenuOtherFunctionalities"].send(player)
	
''' Show rules menu '''
def showMenuRules(player):
	updateMenuRules(players[player])
	popuplib.gPopups["etMenuRules"].send(player)
	
''' Show chat commands menu '''
def showMenuChatCommands(player):
	updateMenuChatCommands(players[player])
	popuplib.gPopups["etMenuChatCommands"].send(player)
	
''' Show console commands menu '''
def showMenuConsoleCommands(player):
	updateMenuConsoleCommands(players[player])
	popuplib.gPopups["etMenuConsoleCommands"].send(player)
	
''' Show classes config info menu '''
def showMenuClassesInfo(player):
	updateMenuClassesInfo(players[player])
	popuplib.gPopups["etMenuClassesInfo"].send(player)
	
''' Show class config info menu '''
def showMenuClassInfo(player):
	updateMenuClassInfo(players[player])
	popuplib.gPopups["etMenuClassInfo"].send(player)
	
''' Show buy menu '''
def showMenuBuy(player):
	updateMenuBuy(players[player])
	popuplib.gPopups["etMenuBuy"].send(player)
	
''' Show class upgrading menu '''
def showMenuUpgradeClass(player):
	updateMenuUpgradeClass(players[player])
	popuplib.gPopups["etMenuUpgradeClass"].send(player)
	
''' Show skills learning menu '''
def showMenuLearnSkills(player):
	updateMenuLearnSkills(players[player])
	popuplib.gPopups["etMenuLearnSkills"].send(player)
	
''' Show armory menu '''
def showMenuArmory(player):
	updateMenuArmory(players[player])
	popuplib.gPopups["etMenuArmory"].send(player)
''' Show skill upgrading menu '''
def showMenuUpgradeSkill(player):
	updateMenuUpgradeSkill(players[player])
	popuplib.gPopups["etMenuUpgradeSkill"].send(player)
	
''' Show skill selection menu '''
def showMenuChooseSkill(player):
	updateMenuChooseSkill(players[player])
	popuplib.gPopups["etMenuChooseSkill"].send(player)
	
''' Show quick stats menu '''
def showMenuQuickStats(player):
	popuplib.unsendname("etMenuQuickStats", player)
	updateMenuQuickStats(players[player])
	popuplib.gPopups["etMenuQuickStats"].send(player)
	
#___________________________________________SERVER EVENTS

# --------------------- #
# SERVER EVENTS #
# --------------------- #
''' Script loaded '''
def load():	
	log("Menus sub-script loaded")	
''' Script unloaded '''
def unload():
	log("Menus sub-script unloaded")
