#================================================================#
# SHOP
#================================================================#

import es
from etmod_2008.logs.logs import log
from etmod_2008.classes.classes import *

#___________________________________________CLASSES

# ------------ #
# CLASSES #
# ------------ #
''' Used to represent what a player has already bought '''
class BoughtStuff:
	def __init__(self):
		self.Classes = {}
		for c in classes.keys():
			self.Classes[c] = {}
			self.Classes[c]["health"] = 0
			self.Classes[c]["armor"] = 0
			self.Classes[c]["speed"] = 0
			self.Classes[c]["primary_ammo_t"] = 0
			self.Classes[c]["primary_ammo_ct"] = 0
			self.Classes[c]["secondary_ammo_t"] = 0
			self.Classes[c]["secondary_ammo_ct"] = 0
			self.Classes[c]["inv_amount_t"] = 0
			self.Classes[c]["inv_amount_ct"] = 0
			self.Classes[c]["better_weapon_t"] = False
			self.Classes[c]["better_weapon_ct"] = False
	def GiveStuff(self, player, team, classname, giveNew = False):
		player = str(player)
		team = int(team)
		classname = str(classname)
		cs = self.Classes[classname]
		c = classes[classname]
		u = c.Upgrades
		
		if cs["health"] > 0: es.server.queuecmd("est_SetHealth " + player + " " + str(c.Health + cs["health"]))
		if cs["armor"] > 0: es.server.queuecmd("est_SetArmor " + player + " " + str(c.Armor + cs["armor"]))
		if cs["speed"] > 0: es.server.queuecmd("est_Speed " + player + " " + str(float(c.Speed + cs["speed"]) / 100))
		if team == 2:
			if c.WeaponPrimaryT is not None and cs["primary_ammo_t"] > 0:
				c.WeaponPrimaryT.SetAmmo(player, int(c.AmmoPrimaryT + cs["primary_ammo_t"]))
			if c.WeaponSecondaryT is not None and cs["secondary_ammo_t"] > 0:
				c.WeaponPrimaryT.SetAmmo(player, int(c.AmmoSecondaryT + cs["secondary_ammo_t"]))
			if cs["better_weapon_t"] and u.BetterWeaponT is not None:
				es.server.queuecmd("est_UnRestrict " + player + " " + u.BetterWeaponT.FullName())
				es.server.queuecmd("est_RemoveWeapon " + player + " 1")
				if giveNew:
					es.server.queuecmd("est_Give " + player + " " + u.BetterWeaponT.FullName())
		elif team == 3:
			if c.WeaponPrimaryCT is not None and cs["primary_ammo_ct"] > 0:
				c.WeaponPrimaryCT.SetAmmo(player, int(c.AmmoPrimaryCT + cs["primary_ammo_ct"]))
			if c.WeaponSecondaryCT is not None and cs["secondary_ammo_ct"] > 0:
				c.WeaponPrimaryCT.SetAmmo(player, int(c.AmmoSecondaryCT + cs["secondary_ammo_ct"]))
			if cs["better_weapon_ct"] and u.BetterWeaponCT is not None:
				es.server.queuecmd("est_UnRestrict " + player + " " + u.BetterWeaponCT.FullName())
				es.server.queuecmd("est_RemoveWeapon " + player + " 1")
				if giveNew:
					es.server.queuecmd("est_Give " + player + " " + u.BetterWeaponCT.FullName())
		
	def Save(self, filename):
		f = None
		#try:
		f = open(os.path.join(os.getcwd(), os.path.join(shopDataPath, filename + ".sh")), "w")
		for c in self.Classes.keys():
			f.write("[" + str(c) + "]\n")
			for k in self.Classes[c].keys():
				f.write(str(k) + "=" + str(int(self.Classes[c][k])) + "\n")
		log("'" + str(filename) + "' shop file successfully saved")
		#except:
		#	log("Error while trying to save '" + str(filename) + "' shop file")
		#finally:
		#	if f is not None:
		f.close()
	def Load(self, filename):
		f = None
		try:
			f = open(os.path.join(os.getcwd(), os.path.join(shopDataPath, filename + ".sh")), "r")
			self.__init__()
			cl = ""
			for line in f:
				line = line.strip("\n")
				line = line.strip("\r")
				if line.startswith("[") and line.endswith("]"):
					cl = line.strip("[]")
					if not self.Classes.has_key(cl):
						self.Classes[cl] = {}
				else:
					parts = line.split("=")
					if len(parts) == 2:
						parts[1] = parts[1].strip("\n")
						parts[1] = parts[1].strip("\r")
						if cl != "":
							if parts[0] == "better_weapon_t" or parts[0] == "better_weapon_ct":
								self.Classes[cl][parts[0]] = (int(parts[1]) == 1)
							else:
								self.Classes[cl][parts[0]] = int(parts[1])
						
			log("'" + str(filename) + "' stats file successfully loaded")
		except:
			log("Error while trying to load '" + str(filename) + "' shop file")
		finally:
			if f is not None:
				f.close()

#___________________________________________DECLARATIONS

# --------------------- #
# DECLARATIONS #
# --------------------- #
shopDataPath = "cstrike/addons/eventscripts/etmod_2008/shop/data"

#___________________________________________SERVER EVENTS

# --------------------- #
# SERVER EVENTS #
# --------------------- #
''' Script loaded '''
def load():	
	log("Shop sub-script loaded")	
''' Script unloaded '''
def unload():
	log("Shop sub-script unloaded")
